searchNodes=[{"doc":"Kafka protocol header","ref":"KlifeProtocol.Header.html","title":"KlifeProtocol.Header","type":"module"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map and return remaining binary data. Response content fields: correlation_id: The correlation ID of this response. (int32 | versions 0+)","ref":"KlifeProtocol.Header.html#deserialize_response/2","title":"KlifeProtocol.Header.deserialize_response/2","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: request_api_key: The API key of this request. (int16 | versions 0+) request_api_version: The API version of this request. (int16 | versions 0+) correlation_id: The correlation ID of this request. (int32 | versions 0+) client_id: The client ID string. (string | versions 1+)","ref":"KlifeProtocol.Header.html#serialize_request/2","title":"KlifeProtocol.Header.serialize_request/2","type":"function"},{"doc":"Kafka protocol AddOffsetsToTxn message Request versions summary: Version 1 is the same as version 0. Version 2 adds the support for new error code PRODUCER_FENCED. Version 3 enables flexible versions. Response versions summary: Starting in version 1, on quota violation brokers send out responses before throttling. Version 2 adds the support for new error code PRODUCER_FENCED. Version 3 enables flexible versions.","ref":"KlifeProtocol.Messages.AddOffsetsToTxn.html","title":"KlifeProtocol.Messages.AddOffsetsToTxn","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.AddOffsetsToTxn.html#api_key/0","title":"KlifeProtocol.Messages.AddOffsetsToTxn.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: Duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) error_code: The response error code, or 0 if there was no error. (int16 | versions 0+)","ref":"KlifeProtocol.Messages.AddOffsetsToTxn.html#deserialize_response/3","title":"KlifeProtocol.Messages.AddOffsetsToTxn.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.AddOffsetsToTxn.html#max_supported_version/0","title":"KlifeProtocol.Messages.AddOffsetsToTxn.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.AddOffsetsToTxn.html#min_supported_version/0","title":"KlifeProtocol.Messages.AddOffsetsToTxn.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: transactional_id: The transactional id corresponding to the transaction. (string | versions 0+) producer_id: Current producer id in use by the transactional id. (int64 | versions 0+) producer_epoch: Current epoch associated with the producer id. (int16 | versions 0+) group_id: The unique group identifier. (string | versions 0+)","ref":"KlifeProtocol.Messages.AddOffsetsToTxn.html#serialize_request/2","title":"KlifeProtocol.Messages.AddOffsetsToTxn.serialize_request/2","type":"function"},{"doc":"Kafka protocol AddPartitionsToTxn message Request versions summary: Version 1 is the same as version 0. Version 2 adds the support for new error code PRODUCER_FENCED. Version 3 enables flexible versions. Version 4 adds VerifyOnly field to check if partitions are already in transaction and adds support to batch multiple transactions. Versions 3 and below will be exclusively used by clients and versions 4 and above will be used by brokers. Response versions summary: Starting in version 1, on quota violation brokers send out responses before throttling. Version 2 adds the support for new error code PRODUCER_FENCED. Version 3 enables flexible versions. Version 4 adds support to batch multiple transactions and a top level error code.","ref":"KlifeProtocol.Messages.AddPartitionsToTxn.html","title":"KlifeProtocol.Messages.AddPartitionsToTxn","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.AddPartitionsToTxn.html#api_key/0","title":"KlifeProtocol.Messages.AddPartitionsToTxn.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: Duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) error_code: The response top level error code. (int16 | versions 4+) results_by_transaction: Results categorized by transactional ID. ([]AddPartitionsToTxnResult | versions 4+) transactional_id: The transactional id corresponding to the transaction. (string | versions 4+) topic_results: The results for each topic. ([]AddPartitionsToTxnTopicResult | versions 4+) name: The topic name. (string | versions 0+) results_by_partition: The results for each partition ([]AddPartitionsToTxnPartitionResult | versions 0+) results_by_topic_v3_and_below: The results for each topic. ([]AddPartitionsToTxnTopicResult | versions 0-3) name: The topic name. (string | versions 0+) results_by_partition: The results for each partition ([]AddPartitionsToTxnPartitionResult | versions 0+)","ref":"KlifeProtocol.Messages.AddPartitionsToTxn.html#deserialize_response/3","title":"KlifeProtocol.Messages.AddPartitionsToTxn.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.AddPartitionsToTxn.html#max_supported_version/0","title":"KlifeProtocol.Messages.AddPartitionsToTxn.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.AddPartitionsToTxn.html#min_supported_version/0","title":"KlifeProtocol.Messages.AddPartitionsToTxn.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: transactions: List of transactions to add partitions to. ([]AddPartitionsToTxnTransaction | versions 4+) transactional_id: The transactional id corresponding to the transaction. (string | versions 4+) producer_id: Current producer id in use by the transactional id. (int64 | versions 4+) producer_epoch: Current epoch associated with the producer id. (int16 | versions 4+) verify_only: Boolean to signify if we want to check if the partition is in the transaction rather than add it. (bool | versions 4+) topics: The partitions to add to the transaction. ([]AddPartitionsToTxnTopic | versions 4+) name: The name of the topic. (string | versions 0+) partitions: The partition indexes to add to the transaction ([]int32 | versions 0+) v3_and_below_transactional_id: The transactional id corresponding to the transaction. (string | versions 0-3) v3_and_below_producer_id: Current producer id in use by the transactional id. (int64 | versions 0-3) v3_and_below_producer_epoch: Current epoch associated with the producer id. (int16 | versions 0-3) v3_and_below_topics: The partitions to add to the transaction. ([]AddPartitionsToTxnTopic | versions 0-3) name: The name of the topic. (string | versions 0+) partitions: The partition indexes to add to the transaction ([]int32 | versions 0+)","ref":"KlifeProtocol.Messages.AddPartitionsToTxn.html#serialize_request/2","title":"KlifeProtocol.Messages.AddPartitionsToTxn.serialize_request/2","type":"function"},{"doc":"Kafka protocol AllocateProducerIds message Request versions summary: Response versions summary:","ref":"KlifeProtocol.Messages.AllocateProducerIds.html","title":"KlifeProtocol.Messages.AllocateProducerIds","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.AllocateProducerIds.html#api_key/0","title":"KlifeProtocol.Messages.AllocateProducerIds.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) error_code: The top level response error code (int16 | versions 0+) producer_id_start: The first producer ID in this range, inclusive (int64 | versions 0+) producer_id_len: The number of producer IDs in this range (int32 | versions 0+)","ref":"KlifeProtocol.Messages.AllocateProducerIds.html#deserialize_response/3","title":"KlifeProtocol.Messages.AllocateProducerIds.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.AllocateProducerIds.html#max_supported_version/0","title":"KlifeProtocol.Messages.AllocateProducerIds.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.AllocateProducerIds.html#min_supported_version/0","title":"KlifeProtocol.Messages.AllocateProducerIds.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: broker_id: The ID of the requesting broker (int32 | versions 0+) broker_epoch: The epoch of the requesting broker (int64 | versions 0+)","ref":"KlifeProtocol.Messages.AllocateProducerIds.html#serialize_request/2","title":"KlifeProtocol.Messages.AllocateProducerIds.serialize_request/2","type":"function"},{"doc":"Kafka protocol AlterClientQuotas message Request versions summary: Response versions summary: Version 1 enables flexible versions.","ref":"KlifeProtocol.Messages.AlterClientQuotas.html","title":"KlifeProtocol.Messages.AlterClientQuotas","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.AlterClientQuotas.html#api_key/0","title":"KlifeProtocol.Messages.AlterClientQuotas.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) entries: The quota configuration entries to alter. ([]EntryData | versions 0+) error_code: The error code, or 0 if the quota alteration succeeded. (int16 | versions 0+) error_message: The error message, or null if the quota alteration succeeded. (string | versions 0+) entity: The quota entity to alter. ([]EntityData | versions 0+) entity_type: The entity type. (string | versions 0+) entity_name: The name of the entity, or null if the default. (string | versions 0+)","ref":"KlifeProtocol.Messages.AlterClientQuotas.html#deserialize_response/3","title":"KlifeProtocol.Messages.AlterClientQuotas.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.AlterClientQuotas.html#max_supported_version/0","title":"KlifeProtocol.Messages.AlterClientQuotas.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.AlterClientQuotas.html#min_supported_version/0","title":"KlifeProtocol.Messages.AlterClientQuotas.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: entries: The quota configuration entries to alter. ([]EntryData | versions 0+) entity: The quota entity to alter. ([]EntityData | versions 0+) entity_type: The entity type. (string | versions 0+) entity_name: The name of the entity, or null if the default. (string | versions 0+) ops: An individual quota configuration entry to alter. ([]OpData | versions 0+) key: The quota configuration key. (string | versions 0+) value: The value to set, otherwise ignored if the value is to be removed. (float64 | versions 0+) remove: Whether the quota configuration value should be removed, otherwise set. (bool | versions 0+) validate_only: Whether the alteration should be validated, but not performed. (bool | versions 0+)","ref":"KlifeProtocol.Messages.AlterClientQuotas.html#serialize_request/2","title":"KlifeProtocol.Messages.AlterClientQuotas.serialize_request/2","type":"function"},{"doc":"Kafka protocol AlterConfigs message Request versions summary: Version 1 is the same as version 0. Version 2 enables flexible versions. Response versions summary: Starting in version 1, on quota violation brokers send out responses before throttling. Version 2 enables flexible versions.","ref":"KlifeProtocol.Messages.AlterConfigs.html","title":"KlifeProtocol.Messages.AlterConfigs","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.AlterConfigs.html#api_key/0","title":"KlifeProtocol.Messages.AlterConfigs.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: Duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) responses: The responses for each resource. ([]AlterConfigsResourceResponse | versions 0+) error_code: The resource error code. (int16 | versions 0+) error_message: The resource error message, or null if there was no error. (string | versions 0+) resource_type: The resource type. (int8 | versions 0+) resource_name: The resource name. (string | versions 0+)","ref":"KlifeProtocol.Messages.AlterConfigs.html#deserialize_response/3","title":"KlifeProtocol.Messages.AlterConfigs.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.AlterConfigs.html#max_supported_version/0","title":"KlifeProtocol.Messages.AlterConfigs.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.AlterConfigs.html#min_supported_version/0","title":"KlifeProtocol.Messages.AlterConfigs.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: resources: The updates for each resource. ([]AlterConfigsResource | versions 0+) resource_type: The resource type. (int8 | versions 0+) resource_name: The resource name. (string | versions 0+) configs: The configurations. ([]AlterableConfig | versions 0+) name: The configuration key name. (string | versions 0+) value: The value to set for the configuration key. (string | versions 0+) validate_only: True if we should validate the request, but not change the configurations. (bool | versions 0+)","ref":"KlifeProtocol.Messages.AlterConfigs.html#serialize_request/2","title":"KlifeProtocol.Messages.AlterConfigs.serialize_request/2","type":"function"},{"doc":"Kafka protocol AlterPartition message Request versions summary: Version 1 adds LeaderRecoveryState field (KIP-704). Version 2 adds TopicId field to replace TopicName field (KIP-841). Version 3 adds the NewIsrEpochs field and deprecates the NewIsr field (KIP-903). Response versions summary: Version 1 adds LeaderRecoveryState field (KIP-704). Version 2 adds TopicId field to replace TopicName field, can return the following new errors: INELIGIBLE_REPLICA, NEW_LEADER_ELECTED and UNKNOWN_TOPIC_ID (KIP-841). Version 3 is the same as vesion 2 (KIP-903).","ref":"KlifeProtocol.Messages.AlterPartition.html","title":"KlifeProtocol.Messages.AlterPartition","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.AlterPartition.html#api_key/0","title":"KlifeProtocol.Messages.AlterPartition.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) error_code: The top level response error code (int16 | versions 0+) topics: ([]TopicData | versions 0+) topic_name: The name of the topic (string | versions 0-1) topic_id: The ID of the topic (uuid | versions 2+) partitions: ([]PartitionData | versions 0+) partition_index: The partition index (int32 | versions 0+) error_code: The partition level error code (int16 | versions 0+) leader_id: The broker ID of the leader. (int32 | versions 0+) leader_epoch: The leader epoch. (int32 | versions 0+) isr: The in-sync replica IDs. ([]int32 | versions 0+) leader_recovery_state: 1 if the partition is recovering from an unclean leader election; 0 otherwise. (int8 | versions 1+) partition_epoch: The current epoch for the partition for KRaft controllers. The current ZK version for the legacy controllers. (int32 | versions 0+)","ref":"KlifeProtocol.Messages.AlterPartition.html#deserialize_response/3","title":"KlifeProtocol.Messages.AlterPartition.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.AlterPartition.html#max_supported_version/0","title":"KlifeProtocol.Messages.AlterPartition.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.AlterPartition.html#min_supported_version/0","title":"KlifeProtocol.Messages.AlterPartition.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: broker_id: The ID of the requesting broker (int32 | versions 0+) broker_epoch: The epoch of the requesting broker (int64 | versions 0+) topics: ([]TopicData | versions 0+) topic_name: The name of the topic to alter ISRs for (string | versions 0-1) topic_id: The ID of the topic to alter ISRs for (uuid | versions 2+) partitions: ([]PartitionData | versions 0+) partition_index: The partition index (int32 | versions 0+) leader_epoch: The leader epoch of this partition (int32 | versions 0+) new_isr: The ISR for this partition. Deprecated since version 3. ([]int32 | versions 0-2) new_isr_with_epochs: ([]BrokerState | versions 3+) broker_id: The ID of the broker. (int32 | versions 3+) broker_epoch: The epoch of the broker. It will be -1 if the epoch check is not supported. (int64 | versions 3+) leader_recovery_state: 1 if the partition is recovering from an unclean leader election; 0 otherwise. (int8 | versions 1+) partition_epoch: The expected epoch of the partition which is being updated. For legacy cluster this is the ZkVersion in the LeaderAndIsr request. (int32 | versions 0+)","ref":"KlifeProtocol.Messages.AlterPartition.html#serialize_request/2","title":"KlifeProtocol.Messages.AlterPartition.serialize_request/2","type":"function"},{"doc":"Kafka protocol AlterPartitionReassignments message Request versions summary: Response versions summary:","ref":"KlifeProtocol.Messages.AlterPartitionReassignments.html","title":"KlifeProtocol.Messages.AlterPartitionReassignments","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.AlterPartitionReassignments.html#api_key/0","title":"KlifeProtocol.Messages.AlterPartitionReassignments.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) error_code: The top-level error code, or 0 if there was no error. (int16 | versions 0+) error_message: The top-level error message, or null if there was no error. (string | versions 0+) responses: The responses to topics to reassign. ([]ReassignableTopicResponse | versions 0+) name: The topic name (string | versions 0+) partitions: The responses to partitions to reassign ([]ReassignablePartitionResponse | versions 0+) partition_index: The partition index. (int32 | versions 0+) error_code: The error code for this partition, or 0 if there was no error. (int16 | versions 0+) error_message: The error message for this partition, or null if there was no error. (string | versions 0+)","ref":"KlifeProtocol.Messages.AlterPartitionReassignments.html#deserialize_response/3","title":"KlifeProtocol.Messages.AlterPartitionReassignments.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.AlterPartitionReassignments.html#max_supported_version/0","title":"KlifeProtocol.Messages.AlterPartitionReassignments.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.AlterPartitionReassignments.html#min_supported_version/0","title":"KlifeProtocol.Messages.AlterPartitionReassignments.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: timeout_ms: The time in ms to wait for the request to complete. (int32 | versions 0+) topics: The topics to reassign. ([]ReassignableTopic | versions 0+) name: The topic name. (string | versions 0+) partitions: The partitions to reassign. ([]ReassignablePartition | versions 0+) partition_index: The partition index. (int32 | versions 0+) replicas: The replicas to place the partitions on, or null to cancel a pending reassignment for this partition. ([]int32 | versions 0+)","ref":"KlifeProtocol.Messages.AlterPartitionReassignments.html#serialize_request/2","title":"KlifeProtocol.Messages.AlterPartitionReassignments.serialize_request/2","type":"function"},{"doc":"Kafka protocol AlterReplicaLogDirs message Request versions summary: Version 1 is the same as version 0. Version 2 enables flexible versions. Response versions summary: Starting in version 1, on quota violation brokers send out responses before throttling. Version 2 enables flexible versions.","ref":"KlifeProtocol.Messages.AlterReplicaLogDirs.html","title":"KlifeProtocol.Messages.AlterReplicaLogDirs","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.AlterReplicaLogDirs.html#api_key/0","title":"KlifeProtocol.Messages.AlterReplicaLogDirs.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: Duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) results: The results for each topic. ([]AlterReplicaLogDirTopicResult | versions 0+) topic_name: The name of the topic. (string | versions 0+) partitions: The results for each partition. ([]AlterReplicaLogDirPartitionResult | versions 0+) partition_index: The partition index. (int32 | versions 0+) error_code: The error code, or 0 if there was no error. (int16 | versions 0+)","ref":"KlifeProtocol.Messages.AlterReplicaLogDirs.html#deserialize_response/3","title":"KlifeProtocol.Messages.AlterReplicaLogDirs.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.AlterReplicaLogDirs.html#max_supported_version/0","title":"KlifeProtocol.Messages.AlterReplicaLogDirs.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.AlterReplicaLogDirs.html#min_supported_version/0","title":"KlifeProtocol.Messages.AlterReplicaLogDirs.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: dirs: The alterations to make for each directory. ([]AlterReplicaLogDir | versions 0+) path: The absolute directory path. (string | versions 0+) topics: The topics to add to the directory. ([]AlterReplicaLogDirTopic | versions 0+) name: The topic name. (string | versions 0+) partitions: The partition indexes. ([]int32 | versions 0+)","ref":"KlifeProtocol.Messages.AlterReplicaLogDirs.html#serialize_request/2","title":"KlifeProtocol.Messages.AlterReplicaLogDirs.serialize_request/2","type":"function"},{"doc":"Kafka protocol AlterUserScramCredentials message Request versions summary: Response versions summary:","ref":"KlifeProtocol.Messages.AlterUserScramCredentials.html","title":"KlifeProtocol.Messages.AlterUserScramCredentials","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.AlterUserScramCredentials.html#api_key/0","title":"KlifeProtocol.Messages.AlterUserScramCredentials.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) results: The results for deletions and alterations, one per affected user. ([]AlterUserScramCredentialsResult | versions 0+) user: The user name. (string | versions 0+) error_code: The error code. (int16 | versions 0+) error_message: The error message, if any. (string | versions 0+)","ref":"KlifeProtocol.Messages.AlterUserScramCredentials.html#deserialize_response/3","title":"KlifeProtocol.Messages.AlterUserScramCredentials.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.AlterUserScramCredentials.html#max_supported_version/0","title":"KlifeProtocol.Messages.AlterUserScramCredentials.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.AlterUserScramCredentials.html#min_supported_version/0","title":"KlifeProtocol.Messages.AlterUserScramCredentials.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: deletions: The SCRAM credentials to remove. ([]ScramCredentialDeletion | versions 0+) name: The user name. (string | versions 0+) mechanism: The SCRAM mechanism. (int8 | versions 0+) upsertions: The SCRAM credentials to update/insert. ([]ScramCredentialUpsertion | versions 0+) name: The user name. (string | versions 0+) mechanism: The SCRAM mechanism. (int8 | versions 0+) iterations: The number of iterations. (int32 | versions 0+) salt: A random salt generated by the client. (bytes | versions 0+) salted_password: The salted password. (bytes | versions 0+)","ref":"KlifeProtocol.Messages.AlterUserScramCredentials.html#serialize_request/2","title":"KlifeProtocol.Messages.AlterUserScramCredentials.serialize_request/2","type":"function"},{"doc":"Kafka protocol ApiVersions message Request versions summary: Versions 0 through 2 of ApiVersionsRequest are the same. Version 3 is the first flexible version and adds ClientSoftwareName and ClientSoftwareVersion. Response versions summary: Version 1 adds throttle time to the response. Starting in version 2, on quota violation, brokers send out responses before throttling. Version 3 is the first flexible version. Tagged fields are only supported in the body but not in the header. The length of the header must not change in order to guarantee the backward compatibility. Starting from Apache Kafka 2.4 (KIP-511), ApiKeys field is populated with the supported versions of the ApiVersionsRequest when an UNSUPPORTED_VERSION error is returned.","ref":"KlifeProtocol.Messages.ApiVersions.html","title":"KlifeProtocol.Messages.ApiVersions","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.ApiVersions.html#api_key/0","title":"KlifeProtocol.Messages.ApiVersions.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: error_code: The top-level error code. (int16 | versions 0+) api_keys: The APIs supported by the broker. ([]ApiVersion | versions 0+) api_key: The API index. (int16 | versions 0+) min_version: The minimum supported version, inclusive. (int16 | versions 0+) max_version: The maximum supported version, inclusive. (int16 | versions 0+) throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 1+) supported_features: Features supported by the broker. ([]SupportedFeatureKey | versions 3+) name: The name of the feature. (string | versions 3+) min_version: The minimum supported version for the feature. (int16 | versions 3+) max_version: The maximum supported version for the feature. (int16 | versions 3+) finalized_features_epoch: The monotonically increasing epoch for the finalized features information. Valid values are &gt;= 0. A value of -1 is special and represents unknown epoch. (int64 | versions 3+) finalized_features: List of cluster-wide finalized features. The information is valid only if FinalizedFeaturesEpoch &gt;= 0. ([]FinalizedFeatureKey | versions 3+) name: The name of the feature. (string | versions 3+) max_version_level: The cluster-wide finalized max version level for the feature. (int16 | versions 3+) min_version_level: The cluster-wide finalized min version level for the feature. (int16 | versions 3+) zk_migration_ready: Set by a KRaft controller if the required configurations for ZK migration are present (bool | versions 3+)","ref":"KlifeProtocol.Messages.ApiVersions.html#deserialize_response/3","title":"KlifeProtocol.Messages.ApiVersions.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.ApiVersions.html#max_supported_version/0","title":"KlifeProtocol.Messages.ApiVersions.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.ApiVersions.html#min_supported_version/0","title":"KlifeProtocol.Messages.ApiVersions.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: client_software_name: The name of the client. (string | versions 3+) client_software_version: The version of the client. (string | versions 3+)","ref":"KlifeProtocol.Messages.ApiVersions.html#serialize_request/2","title":"KlifeProtocol.Messages.ApiVersions.serialize_request/2","type":"function"},{"doc":"Kafka protocol BeginQuorumEpoch message Request versions summary: Response versions summary:","ref":"KlifeProtocol.Messages.BeginQuorumEpoch.html","title":"KlifeProtocol.Messages.BeginQuorumEpoch","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.BeginQuorumEpoch.html#api_key/0","title":"KlifeProtocol.Messages.BeginQuorumEpoch.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: error_code: The top level error code. (int16 | versions 0+) topics: ([]TopicData | versions 0+) topic_name: The topic name. (string | versions 0+) partitions: ([]PartitionData | versions 0+) partition_index: The partition index. (int32 | versions 0+) error_code: (int16 | versions 0+) leader_id: The ID of the current leader or -1 if the leader is unknown. (int32 | versions 0+) leader_epoch: The latest known leader epoch (int32 | versions 0+)","ref":"KlifeProtocol.Messages.BeginQuorumEpoch.html#deserialize_response/3","title":"KlifeProtocol.Messages.BeginQuorumEpoch.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.BeginQuorumEpoch.html#max_supported_version/0","title":"KlifeProtocol.Messages.BeginQuorumEpoch.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.BeginQuorumEpoch.html#min_supported_version/0","title":"KlifeProtocol.Messages.BeginQuorumEpoch.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: cluster_id: (string | versions 0+) topics: ([]TopicData | versions 0+) topic_name: The topic name. (string | versions 0+) partitions: ([]PartitionData | versions 0+) partition_index: The partition index. (int32 | versions 0+) leader_id: The ID of the newly elected leader (int32 | versions 0+) leader_epoch: The epoch of the newly elected leader (int32 | versions 0+)","ref":"KlifeProtocol.Messages.BeginQuorumEpoch.html#serialize_request/2","title":"KlifeProtocol.Messages.BeginQuorumEpoch.serialize_request/2","type":"function"},{"doc":"Kafka protocol BrokerHeartbeat message Request versions summary: Response versions summary:","ref":"KlifeProtocol.Messages.BrokerHeartbeat.html","title":"KlifeProtocol.Messages.BrokerHeartbeat","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.BrokerHeartbeat.html#api_key/0","title":"KlifeProtocol.Messages.BrokerHeartbeat.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: Duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) error_code: The error code, or 0 if there was no error. (int16 | versions 0+) is_caught_up: True if the broker has approximately caught up with the latest metadata. (bool | versions 0+) is_fenced: True if the broker is fenced. (bool | versions 0+) should_shut_down: True if the broker should proceed with its shutdown. (bool | versions 0+)","ref":"KlifeProtocol.Messages.BrokerHeartbeat.html#deserialize_response/3","title":"KlifeProtocol.Messages.BrokerHeartbeat.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.BrokerHeartbeat.html#max_supported_version/0","title":"KlifeProtocol.Messages.BrokerHeartbeat.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.BrokerHeartbeat.html#min_supported_version/0","title":"KlifeProtocol.Messages.BrokerHeartbeat.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: broker_id: The broker ID. (int32 | versions 0+) broker_epoch: The broker epoch. (int64 | versions 0+) current_metadata_offset: The highest metadata offset which the broker has reached. (int64 | versions 0+) want_fence: True if the broker wants to be fenced, false otherwise. (bool | versions 0+) want_shut_down: True if the broker wants to be shut down, false otherwise. (bool | versions 0+)","ref":"KlifeProtocol.Messages.BrokerHeartbeat.html#serialize_request/2","title":"KlifeProtocol.Messages.BrokerHeartbeat.serialize_request/2","type":"function"},{"doc":"Kafka protocol BrokerRegistration message Request versions summary: Response versions summary:","ref":"KlifeProtocol.Messages.BrokerRegistration.html","title":"KlifeProtocol.Messages.BrokerRegistration","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.BrokerRegistration.html#api_key/0","title":"KlifeProtocol.Messages.BrokerRegistration.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: Duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) error_code: The error code, or 0 if there was no error. (int16 | versions 0+) broker_epoch: The broker's assigned epoch, or -1 if none was assigned. (int64 | versions 0+)","ref":"KlifeProtocol.Messages.BrokerRegistration.html#deserialize_response/3","title":"KlifeProtocol.Messages.BrokerRegistration.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.BrokerRegistration.html#max_supported_version/0","title":"KlifeProtocol.Messages.BrokerRegistration.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.BrokerRegistration.html#min_supported_version/0","title":"KlifeProtocol.Messages.BrokerRegistration.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: broker_id: The broker ID. (int32 | versions 0+) cluster_id: The cluster id of the broker process. (string | versions 0+) incarnation_id: The incarnation id of the broker process. (uuid | versions 0+) listeners: The listeners of this broker ([]Listener | versions 0+) name: The name of the endpoint. (string | versions 0+) host: The hostname. (string | versions 0+) port: The port. (uint16 | versions 0+) security_protocol: The security protocol. (int16 | versions 0+) features: The features on this broker ([]Feature | versions 0+) name: The feature name. (string | versions 0+) min_supported_version: The minimum supported feature level. (int16 | versions 0+) max_supported_version: The maximum supported feature level. (int16 | versions 0+) rack: The rack which this broker is in. (string | versions 0+) is_migrating_zk_broker: If the required configurations for ZK migration are present, this value is set to true (bool | versions 1+)","ref":"KlifeProtocol.Messages.BrokerRegistration.html#serialize_request/2","title":"KlifeProtocol.Messages.BrokerRegistration.serialize_request/2","type":"function"},{"doc":"Kafka protocol ConsumerGroupHeartbeat message Request versions summary: The ConsumerGroupHeartbeat API is added as part of KIP-848 and is still under developement. Hence, the API is not exposed by default by brokers unless explicitely enabled. Response versions summary:","ref":"KlifeProtocol.Messages.ConsumerGroupHeartbeat.html","title":"KlifeProtocol.Messages.ConsumerGroupHeartbeat","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.ConsumerGroupHeartbeat.html#api_key/0","title":"KlifeProtocol.Messages.ConsumerGroupHeartbeat.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) error_code: The top-level error code, or 0 if there was no error (int16 | versions 0+) error_message: The top-level error message, or null if there was no error. (string | versions 0+) member_id: The member id generated by the coordinator. Only provided when the member joins with MemberEpoch == 0. (string | versions 0+) member_epoch: The member epoch. (int32 | versions 0+) should_compute_assignment: True if the member should compute the assignment for the group. (bool | versions 0+) heartbeat_interval_ms: The heartbeat interval in milliseconds. (int32 | versions 0+) assignment: null if not provided; the assignment otherwise. (Assignment | versions 0+) error: The assigned error. (int8 | versions 0+) assigned_topic_partitions: The partitions assigned to the member that can be used immediately. ([]TopicPartitions | versions 0+) topic_id: The topic ID. (uuid | versions 0+) partitions: The partitions. ([]int32 | versions 0+) pending_topic_partitions: The partitions assigned to the member that cannot be used because they are not released by their former owners yet. ([]TopicPartitions | versions 0+) topic_id: The topic ID. (uuid | versions 0+) partitions: The partitions. ([]int32 | versions 0+) metadata_version: The version of the metadata. (int16 | versions 0+) metadata_bytes: The assigned metadata. (bytes | versions 0+)","ref":"KlifeProtocol.Messages.ConsumerGroupHeartbeat.html#deserialize_response/3","title":"KlifeProtocol.Messages.ConsumerGroupHeartbeat.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.ConsumerGroupHeartbeat.html#max_supported_version/0","title":"KlifeProtocol.Messages.ConsumerGroupHeartbeat.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.ConsumerGroupHeartbeat.html#min_supported_version/0","title":"KlifeProtocol.Messages.ConsumerGroupHeartbeat.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: group_id: The group identifier. (string | versions 0+) member_id: The member id generated by the coordinator. The member id must be kept during the entire lifetime of the member. (string | versions 0+) member_epoch: The current member epoch; 0 to join the group; -1 to leave the group; -2 to indicate that the static member will rejoin. (int32 | versions 0+) instance_id: null if not provided or if it didn't change since the last heartbeat; the instance Id otherwise. (string | versions 0+) rack_id: null if not provided or if it didn't change since the last heartbeat; the rack ID of consumer otherwise. (string | versions 0+) rebalance_timeout_ms: -1 if it didn't chance since the last heartbeat; the maximum time in milliseconds that the coordinator will wait on the member to revoke its partitions otherwise. (int32 | versions 0+) subscribed_topic_names: null if it didn't change since the last heartbeat; the subscribed topic names otherwise. ([]string | versions 0+) subscribed_topic_regex: null if it didn't change since the last heartbeat; the subscribed topic regex otherwise (string | versions 0+) server_assignor: null if not used or if it didn't change since the last heartbeat; the server side assignor to use otherwise. (string | versions 0+) client_assignors: null if not used or if it didn't change since the last heartbeat; the list of client-side assignors otherwise. ([]Assignor | versions 0+) name: The name of the assignor. (string | versions 0+) minimum_version: The minimum supported version for the metadata. (int16 | versions 0+) maximum_version: The maximum supported version for the metadata. (int16 | versions 0+) reason: The reason of the metadata update. (int8 | versions 0+) metadata_version: The version of the metadata. (int16 | versions 0+) metadata_bytes: The metadata. (bytes | versions 0+) topic_partitions: null if it didn't change since the last heartbeat; the partitions owned by the member. ([]TopicPartitions | versions 0+) topic_id: The topic ID. (uuid | versions 0+) partitions: The partitions. ([]int32 | versions 0+)","ref":"KlifeProtocol.Messages.ConsumerGroupHeartbeat.html#serialize_request/2","title":"KlifeProtocol.Messages.ConsumerGroupHeartbeat.serialize_request/2","type":"function"},{"doc":"Kafka protocol ControlledShutdown message Request versions summary: Version 0 of ControlledShutdownRequest has a non-standard request header which does not include clientId. Version 1 and later use the standard request header. Version 1 is the same as version 0. Version 2 adds BrokerEpoch. Response versions summary: Versions 1 and 2 are the same as version 0.","ref":"KlifeProtocol.Messages.ControlledShutdown.html","title":"KlifeProtocol.Messages.ControlledShutdown","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.ControlledShutdown.html#api_key/0","title":"KlifeProtocol.Messages.ControlledShutdown.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: error_code: The top-level error code. (int16 | versions 0+) remaining_partitions: The partitions that the broker still leads. ([]RemainingPartition | versions 0+) topic_name: The name of the topic. (string | versions 0+) partition_index: The index of the partition. (int32 | versions 0+)","ref":"KlifeProtocol.Messages.ControlledShutdown.html#deserialize_response/3","title":"KlifeProtocol.Messages.ControlledShutdown.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.ControlledShutdown.html#max_supported_version/0","title":"KlifeProtocol.Messages.ControlledShutdown.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.ControlledShutdown.html#min_supported_version/0","title":"KlifeProtocol.Messages.ControlledShutdown.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: broker_id: The id of the broker for which controlled shutdown has been requested. (int32 | versions 0+) broker_epoch: The broker epoch. (int64 | versions 2+)","ref":"KlifeProtocol.Messages.ControlledShutdown.html#serialize_request/2","title":"KlifeProtocol.Messages.ControlledShutdown.serialize_request/2","type":"function"},{"doc":"Kafka protocol CreateAcls message Request versions summary: Version 1 adds resource pattern type. Version 2 enables flexible versions. Version 3 adds user resource type. Response versions summary: Starting in version 1, on quota violation, brokers send out responses before throttling. Version 2 enables flexible versions. Version 3 adds user resource type.","ref":"KlifeProtocol.Messages.CreateAcls.html","title":"KlifeProtocol.Messages.CreateAcls","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.CreateAcls.html#api_key/0","title":"KlifeProtocol.Messages.CreateAcls.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) results: The results for each ACL creation. ([]AclCreationResult | versions 0+) error_code: The result error, or zero if there was no error. (int16 | versions 0+) error_message: The result message, or null if there was no error. (string | versions 0+)","ref":"KlifeProtocol.Messages.CreateAcls.html#deserialize_response/3","title":"KlifeProtocol.Messages.CreateAcls.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.CreateAcls.html#max_supported_version/0","title":"KlifeProtocol.Messages.CreateAcls.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.CreateAcls.html#min_supported_version/0","title":"KlifeProtocol.Messages.CreateAcls.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: creations: The ACLs that we want to create. ([]AclCreation | versions 0+) resource_type: The type of the resource. (int8 | versions 0+) resource_name: The resource name for the ACL. (string | versions 0+) resource_pattern_type: The pattern type for the ACL. (int8 | versions 1+) principal: The principal for the ACL. (string | versions 0+) host: The host for the ACL. (string | versions 0+) operation: The operation type for the ACL (read, write, etc.). (int8 | versions 0+) permission_type: The permission type for the ACL (allow, deny, etc.). (int8 | versions 0+)","ref":"KlifeProtocol.Messages.CreateAcls.html#serialize_request/2","title":"KlifeProtocol.Messages.CreateAcls.serialize_request/2","type":"function"},{"doc":"Kafka protocol CreateDelegationToken message Request versions summary: Version 1 is the same as version 0. Version 2 is the first flexible version. Version 3 adds owner principal Response versions summary: Starting in version 1, on quota violation, brokers send out responses before throttling. Version 2 is the first flexible version. Version 3 adds token requester details","ref":"KlifeProtocol.Messages.CreateDelegationToken.html","title":"KlifeProtocol.Messages.CreateDelegationToken","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.CreateDelegationToken.html#api_key/0","title":"KlifeProtocol.Messages.CreateDelegationToken.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: error_code: The top-level error, or zero if there was no error. (int16 | versions 0+) principal_type: The principal type of the token owner. (string | versions 0+) principal_name: The name of the token owner. (string | versions 0+) token_requester_principal_type: The principal type of the requester of the token. (string | versions 3+) token_requester_principal_name: The principal type of the requester of the token. (string | versions 3+) issue_timestamp_ms: When this token was generated. (int64 | versions 0+) expiry_timestamp_ms: When this token expires. (int64 | versions 0+) max_timestamp_ms: The maximum lifetime of this token. (int64 | versions 0+) token_id: The token UUID. (string | versions 0+) hmac: HMAC of the delegation token. (bytes | versions 0+) throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+)","ref":"KlifeProtocol.Messages.CreateDelegationToken.html#deserialize_response/3","title":"KlifeProtocol.Messages.CreateDelegationToken.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.CreateDelegationToken.html#max_supported_version/0","title":"KlifeProtocol.Messages.CreateDelegationToken.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.CreateDelegationToken.html#min_supported_version/0","title":"KlifeProtocol.Messages.CreateDelegationToken.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: owner_principal_type: The principal type of the owner of the token. If it's null it defaults to the token request principal. (string | versions 3+) owner_principal_name: The principal name of the owner of the token. If it's null it defaults to the token request principal. (string | versions 3+) renewers: A list of those who are allowed to renew this token before it expires. ([]CreatableRenewers | versions 0+) principal_type: The type of the Kafka principal. (string | versions 0+) principal_name: The name of the Kafka principal. (string | versions 0+) max_lifetime_ms: The maximum lifetime of the token in milliseconds, or -1 to use the server side default. (int64 | versions 0+)","ref":"KlifeProtocol.Messages.CreateDelegationToken.html#serialize_request/2","title":"KlifeProtocol.Messages.CreateDelegationToken.serialize_request/2","type":"function"},{"doc":"Kafka protocol CreatePartitions message Request versions summary: Version 1 is the same as version 0. Version 2 adds flexible version support Version 3 is identical to version 2 but may return a THROTTLING_QUOTA_EXCEEDED error in the response if the partitions creation is throttled (KIP-599). Response versions summary: Starting in version 1, on quota violation, brokers send out responses before throttling. Version 2 adds flexible version support Version 3 is identical to version 2 but may return a THROTTLING_QUOTA_EXCEEDED error in the response if the partitions creation is throttled (KIP-599).","ref":"KlifeProtocol.Messages.CreatePartitions.html","title":"KlifeProtocol.Messages.CreatePartitions","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.CreatePartitions.html#api_key/0","title":"KlifeProtocol.Messages.CreatePartitions.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) results: The partition creation results for each topic. ([]CreatePartitionsTopicResult | versions 0+) name: The topic name. (string | versions 0+) error_code: The result error, or zero if there was no error. (int16 | versions 0+) error_message: The result message, or null if there was no error. (string | versions 0+)","ref":"KlifeProtocol.Messages.CreatePartitions.html#deserialize_response/3","title":"KlifeProtocol.Messages.CreatePartitions.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.CreatePartitions.html#max_supported_version/0","title":"KlifeProtocol.Messages.CreatePartitions.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.CreatePartitions.html#min_supported_version/0","title":"KlifeProtocol.Messages.CreatePartitions.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: topics: Each topic that we want to create new partitions inside. ([]CreatePartitionsTopic | versions 0+) name: The topic name. (string | versions 0+) count: The new partition count. (int32 | versions 0+) assignments: The new partition assignments. ([]CreatePartitionsAssignment | versions 0+) broker_ids: The assigned broker IDs. ([]int32 | versions 0+) timeout_ms: The time in ms to wait for the partitions to be created. (int32 | versions 0+) validate_only: If true, then validate the request, but don't actually increase the number of partitions. (bool | versions 0+)","ref":"KlifeProtocol.Messages.CreatePartitions.html#serialize_request/2","title":"KlifeProtocol.Messages.CreatePartitions.serialize_request/2","type":"function"},{"doc":"Kafka protocol CreateTopics message Request versions summary: Version 1 adds validateOnly. Version 4 makes partitions/replicationFactor optional even when assignments are not present (KIP-464) Version 5 is the first flexible version. Version 5 also returns topic configs in the response (KIP-525). Version 6 is identical to version 5 but may return a THROTTLING_QUOTA_EXCEEDED error in the response if the topics creation is throttled (KIP-599). Version 7 is the same as version 6. Response versions summary: Version 1 adds a per-topic error message string. Version 2 adds the throttle time. Starting in version 3, on quota violation, brokers send out responses before throttling. Version 4 makes partitions/replicationFactor optional even when assignments are not present (KIP-464). Version 5 is the first flexible version. Version 5 also returns topic configs in the response (KIP-525). Version 6 is identical to version 5 but may return a THROTTLING_QUOTA_EXCEEDED error in the response if the topics creation is throttled (KIP-599). Version 7 returns the topic ID of the newly created topic if creation is sucessful.","ref":"KlifeProtocol.Messages.CreateTopics.html","title":"KlifeProtocol.Messages.CreateTopics","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.CreateTopics.html#api_key/0","title":"KlifeProtocol.Messages.CreateTopics.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 2+) topics: Results for each topic we tried to create. ([]CreatableTopicResult | versions 0+) name: The topic name. (string | versions 0+) topic_id: The unique topic ID (uuid | versions 7+) error_code: The error code, or 0 if there was no error. (int16 | versions 0+) error_message: The error message, or null if there was no error. (string | versions 1+) topic_config_error_code: Optional topic config error returned if configs are not returned in the response. (int16 | versions 5+) num_partitions: Number of partitions of the topic. (int32 | versions 5+) replication_factor: Replication factor of the topic. (int16 | versions 5+) configs: Configuration of the topic. ([]CreatableTopicConfigs | versions 5+) name: The configuration name. (string | versions 5+) value: The configuration value. (string | versions 5+) read_only: True if the configuration is read-only. (bool | versions 5+) config_source: The configuration source. (int8 | versions 5+) is_sensitive: True if this configuration is sensitive. (bool | versions 5+)","ref":"KlifeProtocol.Messages.CreateTopics.html#deserialize_response/3","title":"KlifeProtocol.Messages.CreateTopics.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.CreateTopics.html#max_supported_version/0","title":"KlifeProtocol.Messages.CreateTopics.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.CreateTopics.html#min_supported_version/0","title":"KlifeProtocol.Messages.CreateTopics.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: topics: The topics to create. ([]CreatableTopic | versions 0+) name: The topic name. (string | versions 0+) num_partitions: The number of partitions to create in the topic, or -1 if we are either specifying a manual partition assignment or using the default partitions. (int32 | versions 0+) replication_factor: The number of replicas to create for each partition in the topic, or -1 if we are either specifying a manual partition assignment or using the default replication factor. (int16 | versions 0+) assignments: The manual partition assignment, or the empty array if we are using automatic assignment. ([]CreatableReplicaAssignment | versions 0+) partition_index: The partition index. (int32 | versions 0+) broker_ids: The brokers to place the partition on. ([]int32 | versions 0+) configs: The custom topic configurations to set. ([]CreateableTopicConfig | versions 0+) name: The configuration name. (string | versions 0+) value: The configuration value. (string | versions 0+) timeout_ms: How long to wait in milliseconds before timing out the request. (int32 | versions 0+) validate_only: If true, check that the topics can be created as specified, but don't create anything. (bool | versions 1+)","ref":"KlifeProtocol.Messages.CreateTopics.html#serialize_request/2","title":"KlifeProtocol.Messages.CreateTopics.serialize_request/2","type":"function"},{"doc":"Kafka protocol DeleteAcls message Request versions summary: Version 1 adds the pattern type. Version 2 enables flexible versions. Version 3 adds the user resource type. Response versions summary: Version 1 adds the resource pattern type. Starting in version 1, on quota violation, brokers send out responses before throttling. Version 2 enables flexible versions. Version 3 adds the user resource type.","ref":"KlifeProtocol.Messages.DeleteAcls.html","title":"KlifeProtocol.Messages.DeleteAcls","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.DeleteAcls.html#api_key/0","title":"KlifeProtocol.Messages.DeleteAcls.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) filter_results: The results for each filter. ([]DeleteAclsFilterResult | versions 0+) error_code: The error code, or 0 if the filter succeeded. (int16 | versions 0+) error_message: The error message, or null if the filter succeeded. (string | versions 0+) matching_acls: The ACLs which matched this filter. ([]DeleteAclsMatchingAcl | versions 0+) error_code: The deletion error code, or 0 if the deletion succeeded. (int16 | versions 0+) error_message: The deletion error message, or null if the deletion succeeded. (string | versions 0+) resource_type: The ACL resource type. (int8 | versions 0+) resource_name: The ACL resource name. (string | versions 0+) pattern_type: The ACL resource pattern type. (int8 | versions 1+) principal: The ACL principal. (string | versions 0+) host: The ACL host. (string | versions 0+) operation: The ACL operation. (int8 | versions 0+) permission_type: The ACL permission type. (int8 | versions 0+)","ref":"KlifeProtocol.Messages.DeleteAcls.html#deserialize_response/3","title":"KlifeProtocol.Messages.DeleteAcls.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.DeleteAcls.html#max_supported_version/0","title":"KlifeProtocol.Messages.DeleteAcls.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.DeleteAcls.html#min_supported_version/0","title":"KlifeProtocol.Messages.DeleteAcls.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: filters: The filters to use when deleting ACLs. ([]DeleteAclsFilter | versions 0+) resource_type_filter: The resource type. (int8 | versions 0+) resource_name_filter: The resource name. (string | versions 0+) pattern_type_filter: The pattern type. (int8 | versions 1+) principal_filter: The principal filter, or null to accept all principals. (string | versions 0+) host_filter: The host filter, or null to accept all hosts. (string | versions 0+) operation: The ACL operation. (int8 | versions 0+) permission_type: The permission type. (int8 | versions 0+)","ref":"KlifeProtocol.Messages.DeleteAcls.html#serialize_request/2","title":"KlifeProtocol.Messages.DeleteAcls.serialize_request/2","type":"function"},{"doc":"Kafka protocol DeleteGroups message Request versions summary: Version 1 is the same as version 0. Version 2 is the first flexible version. Response versions summary: Starting in version 1, on quota violation, brokers send out responses before throttling. Version 2 is the first flexible version.","ref":"KlifeProtocol.Messages.DeleteGroups.html","title":"KlifeProtocol.Messages.DeleteGroups","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.DeleteGroups.html#api_key/0","title":"KlifeProtocol.Messages.DeleteGroups.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) results: The deletion results ([]DeletableGroupResult | versions 0+) group_id: The group id (string | versions 0+) error_code: The deletion error, or 0 if the deletion succeeded. (int16 | versions 0+)","ref":"KlifeProtocol.Messages.DeleteGroups.html#deserialize_response/3","title":"KlifeProtocol.Messages.DeleteGroups.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.DeleteGroups.html#max_supported_version/0","title":"KlifeProtocol.Messages.DeleteGroups.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.DeleteGroups.html#min_supported_version/0","title":"KlifeProtocol.Messages.DeleteGroups.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: groups_names: The group names to delete. ([]string | versions 0+)","ref":"KlifeProtocol.Messages.DeleteGroups.html#serialize_request/2","title":"KlifeProtocol.Messages.DeleteGroups.serialize_request/2","type":"function"},{"doc":"Kafka protocol DeleteRecords message Request versions summary: Version 1 is the same as version 0. Version 2 is the first flexible version. Response versions summary: Starting in version 1, on quota violation, brokers send out responses before throttling. Version 2 is the first flexible version.","ref":"KlifeProtocol.Messages.DeleteRecords.html","title":"KlifeProtocol.Messages.DeleteRecords","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.DeleteRecords.html#api_key/0","title":"KlifeProtocol.Messages.DeleteRecords.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) topics: Each topic that we wanted to delete records from. ([]DeleteRecordsTopicResult | versions 0+) name: The topic name. (string | versions 0+) partitions: Each partition that we wanted to delete records from. ([]DeleteRecordsPartitionResult | versions 0+) partition_index: The partition index. (int32 | versions 0+) low_watermark: The partition low water mark. (int64 | versions 0+) error_code: The deletion error code, or 0 if the deletion succeeded. (int16 | versions 0+)","ref":"KlifeProtocol.Messages.DeleteRecords.html#deserialize_response/3","title":"KlifeProtocol.Messages.DeleteRecords.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.DeleteRecords.html#max_supported_version/0","title":"KlifeProtocol.Messages.DeleteRecords.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.DeleteRecords.html#min_supported_version/0","title":"KlifeProtocol.Messages.DeleteRecords.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: topics: Each topic that we want to delete records from. ([]DeleteRecordsTopic | versions 0+) name: The topic name. (string | versions 0+) partitions: Each partition that we want to delete records from. ([]DeleteRecordsPartition | versions 0+) partition_index: The partition index. (int32 | versions 0+) offset: The deletion offset. (int64 | versions 0+) timeout_ms: How long to wait for the deletion to complete, in milliseconds. (int32 | versions 0+)","ref":"KlifeProtocol.Messages.DeleteRecords.html#serialize_request/2","title":"KlifeProtocol.Messages.DeleteRecords.serialize_request/2","type":"function"},{"doc":"Kafka protocol DeleteTopics message Request versions summary: Versions 0, 1, 2, and 3 are the same. Version 4 is the first flexible version. Version 5 adds ErrorMessage in the response and may return a THROTTLING_QUOTA_EXCEEDED error in the response if the topics deletion is throttled (KIP-599). Version 6 reorganizes topics, adds topic IDs and allows topic names to be null. Response versions summary: Version 1 adds the throttle time. Starting in version 2, on quota violation, brokers send out responses before throttling. Starting in version 3, a TOPIC_DELETION_DISABLED error code may be returned. Version 4 is the first flexible version. Version 5 adds ErrorMessage in the response and may return a THROTTLING_QUOTA_EXCEEDED error in the response if the topics deletion is throttled (KIP-599). Version 6 adds topic ID to responses. An UNSUPPORTED_VERSION error code will be returned when attempting to delete using topic IDs when IBP &lt; 2.8. UNKNOWN_TOPIC_ID error code will be returned when IBP is at least 2.8, but the topic ID was not found.","ref":"KlifeProtocol.Messages.DeleteTopics.html","title":"KlifeProtocol.Messages.DeleteTopics","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.DeleteTopics.html#api_key/0","title":"KlifeProtocol.Messages.DeleteTopics.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 1+) responses: The results for each topic we tried to delete. ([]DeletableTopicResult | versions 0+) name: The topic name (string | versions 0+) topic_id: the unique topic ID (uuid | versions 6+) error_code: The deletion error, or 0 if the deletion succeeded. (int16 | versions 0+) error_message: The error message, or null if there was no error. (string | versions 5+)","ref":"KlifeProtocol.Messages.DeleteTopics.html#deserialize_response/3","title":"KlifeProtocol.Messages.DeleteTopics.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.DeleteTopics.html#max_supported_version/0","title":"KlifeProtocol.Messages.DeleteTopics.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.DeleteTopics.html#min_supported_version/0","title":"KlifeProtocol.Messages.DeleteTopics.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: topics: The name or topic ID of the topic ([]DeleteTopicState | versions 6+) name: The topic name (string | versions 6+) topic_id: The unique topic ID (uuid | versions 6+) topic_names: The names of the topics to delete ([]string | versions 0-5) timeout_ms: The length of time in milliseconds to wait for the deletions to complete. (int32 | versions 0+)","ref":"KlifeProtocol.Messages.DeleteTopics.html#serialize_request/2","title":"KlifeProtocol.Messages.DeleteTopics.serialize_request/2","type":"function"},{"doc":"Kafka protocol DescribeAcls message Request versions summary: Version 1 adds resource pattern type. Version 2 enables flexible versions. Version 3 adds user resource type. Response versions summary: Version 1 adds PatternType. Starting in version 1, on quota violation, brokers send out responses before throttling. Version 2 enables flexible versions. Version 3 adds user resource type.","ref":"KlifeProtocol.Messages.DescribeAcls.html","title":"KlifeProtocol.Messages.DescribeAcls","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.DescribeAcls.html#api_key/0","title":"KlifeProtocol.Messages.DescribeAcls.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) error_code: The error code, or 0 if there was no error. (int16 | versions 0+) error_message: The error message, or null if there was no error. (string | versions 0+) resources: Each Resource that is referenced in an ACL. ([]DescribeAclsResource | versions 0+) resource_type: The resource type. (int8 | versions 0+) resource_name: The resource name. (string | versions 0+) pattern_type: The resource pattern type. (int8 | versions 1+) acls: The ACLs. ([]AclDescription | versions 0+) principal: The ACL principal. (string | versions 0+) host: The ACL host. (string | versions 0+) operation: The ACL operation. (int8 | versions 0+) permission_type: The ACL permission type. (int8 | versions 0+)","ref":"KlifeProtocol.Messages.DescribeAcls.html#deserialize_response/3","title":"KlifeProtocol.Messages.DescribeAcls.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.DescribeAcls.html#max_supported_version/0","title":"KlifeProtocol.Messages.DescribeAcls.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.DescribeAcls.html#min_supported_version/0","title":"KlifeProtocol.Messages.DescribeAcls.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: resource_type_filter: The resource type. (int8 | versions 0+) resource_name_filter: The resource name, or null to match any resource name. (string | versions 0+) pattern_type_filter: The resource pattern to match. (int8 | versions 1+) principal_filter: The principal to match, or null to match any principal. (string | versions 0+) host_filter: The host to match, or null to match any host. (string | versions 0+) operation: The operation to match. (int8 | versions 0+) permission_type: The permission type to match. (int8 | versions 0+)","ref":"KlifeProtocol.Messages.DescribeAcls.html#serialize_request/2","title":"KlifeProtocol.Messages.DescribeAcls.serialize_request/2","type":"function"},{"doc":"Kafka protocol DescribeClientQuotas message Request versions summary: Version 1 enables flexible versions. Response versions summary: Version 1 enables flexible versions.","ref":"KlifeProtocol.Messages.DescribeClientQuotas.html","title":"KlifeProtocol.Messages.DescribeClientQuotas","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.DescribeClientQuotas.html#api_key/0","title":"KlifeProtocol.Messages.DescribeClientQuotas.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) error_code: The error code, or 0 if the quota description succeeded. (int16 | versions 0+) error_message: The error message, or null if the quota description succeeded. (string | versions 0+) entries: A result entry. ([]EntryData | versions 0+) entity: The quota entity description. ([]EntityData | versions 0+) entity_type: The entity type. (string | versions 0+) entity_name: The entity name, or null if the default. (string | versions 0+) values: The quota values for the entity. ([]ValueData | versions 0+) key: The quota configuration key. (string | versions 0+) value: The quota configuration value. (float64 | versions 0+)","ref":"KlifeProtocol.Messages.DescribeClientQuotas.html#deserialize_response/3","title":"KlifeProtocol.Messages.DescribeClientQuotas.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.DescribeClientQuotas.html#max_supported_version/0","title":"KlifeProtocol.Messages.DescribeClientQuotas.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.DescribeClientQuotas.html#min_supported_version/0","title":"KlifeProtocol.Messages.DescribeClientQuotas.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: components: Filter components to apply to quota entities. ([]ComponentData | versions 0+) entity_type: The entity type that the filter component applies to. (string | versions 0+) match_type: How to match the entity {0 = exact name, 1 = default name, 2 = any specified name}. (int8 | versions 0+) match: The string to match against, or null if unused for the match type. (string | versions 0+) strict: Whether the match is strict, i.e. should exclude entities with unspecified entity types. (bool | versions 0+)","ref":"KlifeProtocol.Messages.DescribeClientQuotas.html#serialize_request/2","title":"KlifeProtocol.Messages.DescribeClientQuotas.serialize_request/2","type":"function"},{"doc":"Kafka protocol DescribeCluster message Request versions summary: Response versions summary:","ref":"KlifeProtocol.Messages.DescribeCluster.html","title":"KlifeProtocol.Messages.DescribeCluster","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.DescribeCluster.html#api_key/0","title":"KlifeProtocol.Messages.DescribeCluster.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) error_code: The top-level error code, or 0 if there was no error (int16 | versions 0+) error_message: The top-level error message, or null if there was no error. (string | versions 0+) cluster_id: The cluster ID that responding broker belongs to. (string | versions 0+) controller_id: The ID of the controller broker. (int32 | versions 0+) brokers: Each broker in the response. ([]DescribeClusterBroker | versions 0+) broker_id: The broker ID. (int32 | versions 0+) host: The broker hostname. (string | versions 0+) port: The broker port. (int32 | versions 0+) rack: The rack of the broker, or null if it has not been assigned to a rack. (string | versions 0+) cluster_authorized_operations: 32-bit bitfield to represent authorized operations for this cluster. (int32 | versions 0+)","ref":"KlifeProtocol.Messages.DescribeCluster.html#deserialize_response/3","title":"KlifeProtocol.Messages.DescribeCluster.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.DescribeCluster.html#max_supported_version/0","title":"KlifeProtocol.Messages.DescribeCluster.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.DescribeCluster.html#min_supported_version/0","title":"KlifeProtocol.Messages.DescribeCluster.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: include_cluster_authorized_operations: Whether to include cluster authorized operations. (bool | versions 0+)","ref":"KlifeProtocol.Messages.DescribeCluster.html#serialize_request/2","title":"KlifeProtocol.Messages.DescribeCluster.serialize_request/2","type":"function"},{"doc":"Kafka protocol DescribeConfigs message Request versions summary: Version 1 adds IncludeSynonyms. Version 2 is the same as version 1. Version 4 enables flexible versions. Response versions summary: Version 1 adds ConfigSource and the synonyms. Starting in version 2, on quota violation, brokers send out responses before throttling. Version 4 enables flexible versions.","ref":"KlifeProtocol.Messages.DescribeConfigs.html","title":"KlifeProtocol.Messages.DescribeConfigs","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.DescribeConfigs.html#api_key/0","title":"KlifeProtocol.Messages.DescribeConfigs.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) results: The results for each resource. ([]DescribeConfigsResult | versions 0+) error_code: The error code, or 0 if we were able to successfully describe the configurations. (int16 | versions 0+) error_message: The error message, or null if we were able to successfully describe the configurations. (string | versions 0+) resource_type: The resource type. (int8 | versions 0+) resource_name: The resource name. (string | versions 0+) configs: Each listed configuration. ([]DescribeConfigsResourceResult | versions 0+) name: The configuration name. (string | versions 0+) value: The configuration value. (string | versions 0+) read_only: True if the configuration is read-only. (bool | versions 0+) is_default: True if the configuration is not set. (bool | versions 0) config_source: The configuration source. (int8 | versions 1+) is_sensitive: True if this configuration is sensitive. (bool | versions 0+) synonyms: The synonyms for this configuration key. ([]DescribeConfigsSynonym | versions 1+) name: The synonym name. (string | versions 1+) value: The synonym value. (string | versions 1+) source: The synonym source. (int8 | versions 1+) config_type: The configuration data type. Type can be one of the following values - BOOLEAN, STRING, INT, SHORT, LONG, DOUBLE, LIST, CLASS, PASSWORD (int8 | versions 3+) documentation: The configuration documentation. (string | versions 3+)","ref":"KlifeProtocol.Messages.DescribeConfigs.html#deserialize_response/3","title":"KlifeProtocol.Messages.DescribeConfigs.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.DescribeConfigs.html#max_supported_version/0","title":"KlifeProtocol.Messages.DescribeConfigs.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.DescribeConfigs.html#min_supported_version/0","title":"KlifeProtocol.Messages.DescribeConfigs.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: resources: The resources whose configurations we want to describe. ([]DescribeConfigsResource | versions 0+) resource_type: The resource type. (int8 | versions 0+) resource_name: The resource name. (string | versions 0+) configuration_keys: The configuration keys to list, or null to list all configuration keys. ([]string | versions 0+) include_synonyms: True if we should include all synonyms. (bool | versions 1+) include_documentation: True if we should include configuration documentation. (bool | versions 3+)","ref":"KlifeProtocol.Messages.DescribeConfigs.html#serialize_request/2","title":"KlifeProtocol.Messages.DescribeConfigs.serialize_request/2","type":"function"},{"doc":"Kafka protocol DescribeDelegationToken message Request versions summary: Version 1 is the same as version 0. Version 2 adds flexible version support Version 3 adds token requester into the response Response versions summary: Starting in version 1, on quota violation, brokers send out responses before throttling. Version 2 adds flexible version support Version 3 adds token requester details","ref":"KlifeProtocol.Messages.DescribeDelegationToken.html","title":"KlifeProtocol.Messages.DescribeDelegationToken","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.DescribeDelegationToken.html#api_key/0","title":"KlifeProtocol.Messages.DescribeDelegationToken.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: error_code: The error code, or 0 if there was no error. (int16 | versions 0+) tokens: The tokens. ([]DescribedDelegationToken | versions 0+) principal_type: The token principal type. (string | versions 0+) principal_name: The token principal name. (string | versions 0+) token_requester_principal_type: The principal type of the requester of the token. (string | versions 3+) token_requester_principal_name: The principal type of the requester of the token. (string | versions 3+) issue_timestamp: The token issue timestamp in milliseconds. (int64 | versions 0+) expiry_timestamp: The token expiry timestamp in milliseconds. (int64 | versions 0+) max_timestamp: The token maximum timestamp length in milliseconds. (int64 | versions 0+) token_id: The token ID. (string | versions 0+) hmac: The token HMAC. (bytes | versions 0+) renewers: Those who are able to renew this token before it expires. ([]DescribedDelegationTokenRenewer | versions 0+) principal_type: The renewer principal type (string | versions 0+) principal_name: The renewer principal name (string | versions 0+) throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+)","ref":"KlifeProtocol.Messages.DescribeDelegationToken.html#deserialize_response/3","title":"KlifeProtocol.Messages.DescribeDelegationToken.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.DescribeDelegationToken.html#max_supported_version/0","title":"KlifeProtocol.Messages.DescribeDelegationToken.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.DescribeDelegationToken.html#min_supported_version/0","title":"KlifeProtocol.Messages.DescribeDelegationToken.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: owners: Each owner that we want to describe delegation tokens for, or null to describe all tokens. ([]DescribeDelegationTokenOwner | versions 0+) principal_type: The owner principal type. (string | versions 0+) principal_name: The owner principal name. (string | versions 0+)","ref":"KlifeProtocol.Messages.DescribeDelegationToken.html#serialize_request/2","title":"KlifeProtocol.Messages.DescribeDelegationToken.serialize_request/2","type":"function"},{"doc":"Kafka protocol DescribeGroups message Request versions summary: Versions 1 and 2 are the same as version 0. Starting in version 3, authorized operations can be requested. Starting in version 4, the response will include group.instance.id info for members. Version 5 is the first flexible version. Response versions summary: Version 1 added throttle time. Starting in version 2, on quota violation, brokers send out responses before throttling. Starting in version 3, brokers can send authorized operations. Starting in version 4, the response will optionally include group.instance.id info for members. Version 5 is the first flexible version.","ref":"KlifeProtocol.Messages.DescribeGroups.html","title":"KlifeProtocol.Messages.DescribeGroups","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.DescribeGroups.html#api_key/0","title":"KlifeProtocol.Messages.DescribeGroups.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 1+) groups: Each described group. ([]DescribedGroup | versions 0+) error_code: The describe error, or 0 if there was no error. (int16 | versions 0+) group_id: The group ID string. (string | versions 0+) group_state: The group state string, or the empty string. (string | versions 0+) protocol_type: The group protocol type, or the empty string. (string | versions 0+) protocol_data: The group protocol data, or the empty string. (string | versions 0+) members: The group members. ([]DescribedGroupMember | versions 0+) member_id: The member ID assigned by the group coordinator. (string | versions 0+) group_instance_id: The unique identifier of the consumer instance provided by end user. (string | versions 4+) client_id: The client ID used in the member's latest join group request. (string | versions 0+) client_host: The client host. (string | versions 0+) member_metadata: The metadata corresponding to the current group protocol in use. (bytes | versions 0+) member_assignment: The current assignment provided by the group leader. (bytes | versions 0+) authorized_operations: 32-bit bitfield to represent authorized operations for this group. (int32 | versions 3+)","ref":"KlifeProtocol.Messages.DescribeGroups.html#deserialize_response/3","title":"KlifeProtocol.Messages.DescribeGroups.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.DescribeGroups.html#max_supported_version/0","title":"KlifeProtocol.Messages.DescribeGroups.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.DescribeGroups.html#min_supported_version/0","title":"KlifeProtocol.Messages.DescribeGroups.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: groups: The names of the groups to describe ([]string | versions 0+) include_authorized_operations: Whether to include authorized operations. (bool | versions 3+)","ref":"KlifeProtocol.Messages.DescribeGroups.html#serialize_request/2","title":"KlifeProtocol.Messages.DescribeGroups.serialize_request/2","type":"function"},{"doc":"Kafka protocol DescribeLogDirs message Request versions summary: Version 1 is the same as version 0. Response versions summary: Starting in version 1, on quota violation, brokers send out responses before throttling.","ref":"KlifeProtocol.Messages.DescribeLogDirs.html","title":"KlifeProtocol.Messages.DescribeLogDirs","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.DescribeLogDirs.html#api_key/0","title":"KlifeProtocol.Messages.DescribeLogDirs.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) error_code: The error code, or 0 if there was no error. (int16 | versions 3+) results: The log directories. ([]DescribeLogDirsResult | versions 0+) error_code: The error code, or 0 if there was no error. (int16 | versions 0+) log_dir: The absolute log directory path. (string | versions 0+) topics: Each topic. ([]DescribeLogDirsTopic | versions 0+) name: The topic name. (string | versions 0+) partitions: ([]DescribeLogDirsPartition | versions 0+) partition_index: The partition index. (int32 | versions 0+) partition_size: The size of the log segments in this partition in bytes. (int64 | versions 0+) offset_lag: The lag of the log's LEO w.r.t. partition's HW (if it is the current log for the partition) or current replica's LEO (if it is the future log for the partition) (int64 | versions 0+) is_future_key: True if this log is created by AlterReplicaLogDirsRequest and will replace the current log of the replica in the future. (bool | versions 0+) total_bytes: The total size in bytes of the volume the log directory is in. (int64 | versions 4+) usable_bytes: The usable size in bytes of the volume the log directory is in. (int64 | versions 4+)","ref":"KlifeProtocol.Messages.DescribeLogDirs.html#deserialize_response/3","title":"KlifeProtocol.Messages.DescribeLogDirs.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.DescribeLogDirs.html#max_supported_version/0","title":"KlifeProtocol.Messages.DescribeLogDirs.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.DescribeLogDirs.html#min_supported_version/0","title":"KlifeProtocol.Messages.DescribeLogDirs.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: topics: Each topic that we want to describe log directories for, or null for all topics. ([]DescribableLogDirTopic | versions 0+) topic: The topic name (string | versions 0+) partitions: The partition indexes. ([]int32 | versions 0+)","ref":"KlifeProtocol.Messages.DescribeLogDirs.html#serialize_request/2","title":"KlifeProtocol.Messages.DescribeLogDirs.serialize_request/2","type":"function"},{"doc":"Kafka protocol DescribeProducers message Request versions summary: Response versions summary:","ref":"KlifeProtocol.Messages.DescribeProducers.html","title":"KlifeProtocol.Messages.DescribeProducers","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.DescribeProducers.html#api_key/0","title":"KlifeProtocol.Messages.DescribeProducers.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) topics: Each topic in the response. ([]TopicResponse | versions 0+) name: The topic name (string | versions 0+) partitions: Each partition in the response. ([]PartitionResponse | versions 0+) partition_index: The partition index. (int32 | versions 0+) error_code: The partition error code, or 0 if there was no error. (int16 | versions 0+) error_message: The partition error message, which may be null if no additional details are available (string | versions 0+) active_producers: ([]ProducerState | versions 0+) producer_id: (int64 | versions 0+) producer_epoch: (int32 | versions 0+) last_sequence: (int32 | versions 0+) last_timestamp: (int64 | versions 0+) coordinator_epoch: (int32 | versions 0+) current_txn_start_offset: (int64 | versions 0+)","ref":"KlifeProtocol.Messages.DescribeProducers.html#deserialize_response/3","title":"KlifeProtocol.Messages.DescribeProducers.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.DescribeProducers.html#max_supported_version/0","title":"KlifeProtocol.Messages.DescribeProducers.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.DescribeProducers.html#min_supported_version/0","title":"KlifeProtocol.Messages.DescribeProducers.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: topics: ([]TopicRequest | versions 0+) name: The topic name. (string | versions 0+) partition_indexes: The indexes of the partitions to list producers for. ([]int32 | versions 0+)","ref":"KlifeProtocol.Messages.DescribeProducers.html#serialize_request/2","title":"KlifeProtocol.Messages.DescribeProducers.serialize_request/2","type":"function"},{"doc":"Kafka protocol DescribeQuorum message Request versions summary: Version 1 adds additional fields in the response. The request is unchanged (KIP-836). Response versions summary: Version 1 adds LastFetchTimeStamp and LastCaughtUpTimestamp in ReplicaState (KIP-836).","ref":"KlifeProtocol.Messages.DescribeQuorum.html","title":"KlifeProtocol.Messages.DescribeQuorum","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.DescribeQuorum.html#api_key/0","title":"KlifeProtocol.Messages.DescribeQuorum.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: error_code: The top level error code. (int16 | versions 0+) topics: ([]TopicData | versions 0+) topic_name: The topic name. (string | versions 0+) partitions: ([]PartitionData | versions 0+) partition_index: The partition index. (int32 | versions 0+) error_code: (int16 | versions 0+) leader_id: The ID of the current leader or -1 if the leader is unknown. (int32 | versions 0+) leader_epoch: The latest known leader epoch (int32 | versions 0+) high_watermark: (int64 | versions 0+) current_voters: ([]ReplicaState | versions 0+) replica_id: (int32 | versions 0+) log_end_offset: The last known log end offset of the follower or -1 if it is unknown (int64 | versions 0+) last_fetch_timestamp: The last known leader wall clock time time when a follower fetched from the leader. This is reported as -1 both for the current leader or if it is unknown for a voter (int64 | versions 1+) last_caught_up_timestamp: The leader wall clock append time of the offset for which the follower made the most recent fetch request. This is reported as the current time for the leader and -1 if unknown for a voter (int64 | versions 1+) observers: ([]ReplicaState | versions 0+) replica_id: (int32 | versions 0+) log_end_offset: The last known log end offset of the follower or -1 if it is unknown (int64 | versions 0+) last_fetch_timestamp: The last known leader wall clock time time when a follower fetched from the leader. This is reported as -1 both for the current leader or if it is unknown for a voter (int64 | versions 1+) last_caught_up_timestamp: The leader wall clock append time of the offset for which the follower made the most recent fetch request. This is reported as the current time for the leader and -1 if unknown for a voter (int64 | versions 1+)","ref":"KlifeProtocol.Messages.DescribeQuorum.html#deserialize_response/3","title":"KlifeProtocol.Messages.DescribeQuorum.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.DescribeQuorum.html#max_supported_version/0","title":"KlifeProtocol.Messages.DescribeQuorum.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.DescribeQuorum.html#min_supported_version/0","title":"KlifeProtocol.Messages.DescribeQuorum.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: topics: ([]TopicData | versions 0+) topic_name: The topic name. (string | versions 0+) partitions: ([]PartitionData | versions 0+) partition_index: The partition index. (int32 | versions 0+)","ref":"KlifeProtocol.Messages.DescribeQuorum.html#serialize_request/2","title":"KlifeProtocol.Messages.DescribeQuorum.serialize_request/2","type":"function"},{"doc":"Kafka protocol DescribeTransactions message Request versions summary: Response versions summary:","ref":"KlifeProtocol.Messages.DescribeTransactions.html","title":"KlifeProtocol.Messages.DescribeTransactions","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.DescribeTransactions.html#api_key/0","title":"KlifeProtocol.Messages.DescribeTransactions.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) transaction_states: ([]TransactionState | versions 0+) error_code: (int16 | versions 0+) transactional_id: (string | versions 0+) transaction_state: (string | versions 0+) transaction_timeout_ms: (int32 | versions 0+) transaction_start_time_ms: (int64 | versions 0+) producer_id: (int64 | versions 0+) producer_epoch: (int16 | versions 0+) topics: The set of partitions included in the current transaction (if active). When a transaction is preparing to commit or abort, this will include only partitions which do not have markers. ([]TopicData | versions 0+) topic: (string | versions 0+) partitions: ([]int32 | versions 0+)","ref":"KlifeProtocol.Messages.DescribeTransactions.html#deserialize_response/3","title":"KlifeProtocol.Messages.DescribeTransactions.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.DescribeTransactions.html#max_supported_version/0","title":"KlifeProtocol.Messages.DescribeTransactions.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.DescribeTransactions.html#min_supported_version/0","title":"KlifeProtocol.Messages.DescribeTransactions.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: transactional_ids: Array of transactionalIds to include in describe results. If empty, then no results will be returned. ([]string | versions 0+)","ref":"KlifeProtocol.Messages.DescribeTransactions.html#serialize_request/2","title":"KlifeProtocol.Messages.DescribeTransactions.serialize_request/2","type":"function"},{"doc":"Kafka protocol DescribeUserScramCredentials message Request versions summary: Response versions summary:","ref":"KlifeProtocol.Messages.DescribeUserScramCredentials.html","title":"KlifeProtocol.Messages.DescribeUserScramCredentials","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.DescribeUserScramCredentials.html#api_key/0","title":"KlifeProtocol.Messages.DescribeUserScramCredentials.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) error_code: The message-level error code, 0 except for user authorization or infrastructure issues. (int16 | versions 0+) error_message: The message-level error message, if any. (string | versions 0+) results: The results for descriptions, one per user. ([]DescribeUserScramCredentialsResult | versions 0+) user: The user name. (string | versions 0+) error_code: The user-level error code. (int16 | versions 0+) error_message: The user-level error message, if any. (string | versions 0+) credential_infos: The mechanism and related information associated with the user's SCRAM credentials. ([]CredentialInfo | versions 0+) mechanism: The SCRAM mechanism. (int8 | versions 0+) iterations: The number of iterations used in the SCRAM credential. (int32 | versions 0+)","ref":"KlifeProtocol.Messages.DescribeUserScramCredentials.html#deserialize_response/3","title":"KlifeProtocol.Messages.DescribeUserScramCredentials.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.DescribeUserScramCredentials.html#max_supported_version/0","title":"KlifeProtocol.Messages.DescribeUserScramCredentials.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.DescribeUserScramCredentials.html#min_supported_version/0","title":"KlifeProtocol.Messages.DescribeUserScramCredentials.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: users: The users to describe, or null/empty to describe all users. ([]UserName | versions 0+) name: The user name. (string | versions 0+)","ref":"KlifeProtocol.Messages.DescribeUserScramCredentials.html#serialize_request/2","title":"KlifeProtocol.Messages.DescribeUserScramCredentials.serialize_request/2","type":"function"},{"doc":"Kafka protocol ElectLeaders message Request versions summary: Version 1 implements multiple leader election types, as described by KIP-460. Version 2 is the first flexible version. Response versions summary: Version 1 adds a top-level error code. Version 2 is the first flexible version.","ref":"KlifeProtocol.Messages.ElectLeaders.html","title":"KlifeProtocol.Messages.ElectLeaders","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.ElectLeaders.html#api_key/0","title":"KlifeProtocol.Messages.ElectLeaders.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) error_code: The top level response error code. (int16 | versions 1+) replica_election_results: The election results, or an empty array if the requester did not have permission and the request asks for all partitions. ([]ReplicaElectionResult | versions 0+) topic: The topic name (string | versions 0+) partition_result: The results for each partition ([]PartitionResult | versions 0+) partition_id: The partition id (int32 | versions 0+) error_code: The result error, or zero if there was no error. (int16 | versions 0+) error_message: The result message, or null if there was no error. (string | versions 0+)","ref":"KlifeProtocol.Messages.ElectLeaders.html#deserialize_response/3","title":"KlifeProtocol.Messages.ElectLeaders.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.ElectLeaders.html#max_supported_version/0","title":"KlifeProtocol.Messages.ElectLeaders.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.ElectLeaders.html#min_supported_version/0","title":"KlifeProtocol.Messages.ElectLeaders.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: election_type: Type of elections to conduct for the partition. A value of '0' elects the preferred replica. A value of '1' elects the first live replica if there are no in-sync replica. (int8 | versions 1+) topic_partitions: The topic partitions to elect leaders. ([]TopicPartitions | versions 0+) topic: The name of a topic. (string | versions 0+) partitions: The partitions of this topic whose leader should be elected. ([]int32 | versions 0+) timeout_ms: The time in ms to wait for the election to complete. (int32 | versions 0+)","ref":"KlifeProtocol.Messages.ElectLeaders.html#serialize_request/2","title":"KlifeProtocol.Messages.ElectLeaders.serialize_request/2","type":"function"},{"doc":"Kafka protocol EndQuorumEpoch message Request versions summary: Response versions summary:","ref":"KlifeProtocol.Messages.EndQuorumEpoch.html","title":"KlifeProtocol.Messages.EndQuorumEpoch","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.EndQuorumEpoch.html#api_key/0","title":"KlifeProtocol.Messages.EndQuorumEpoch.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: error_code: The top level error code. (int16 | versions 0+) topics: ([]TopicData | versions 0+) topic_name: The topic name. (string | versions 0+) partitions: ([]PartitionData | versions 0+) partition_index: The partition index. (int32 | versions 0+) error_code: (int16 | versions 0+) leader_id: The ID of the current leader or -1 if the leader is unknown. (int32 | versions 0+) leader_epoch: The latest known leader epoch (int32 | versions 0+)","ref":"KlifeProtocol.Messages.EndQuorumEpoch.html#deserialize_response/3","title":"KlifeProtocol.Messages.EndQuorumEpoch.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.EndQuorumEpoch.html#max_supported_version/0","title":"KlifeProtocol.Messages.EndQuorumEpoch.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.EndQuorumEpoch.html#min_supported_version/0","title":"KlifeProtocol.Messages.EndQuorumEpoch.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: cluster_id: (string | versions 0+) topics: ([]TopicData | versions 0+) topic_name: The topic name. (string | versions 0+) partitions: ([]PartitionData | versions 0+) partition_index: The partition index. (int32 | versions 0+) leader_id: The current leader ID that is resigning (int32 | versions 0+) leader_epoch: The current epoch (int32 | versions 0+) preferred_successors: A sorted list of preferred successors to start the election ([]int32 | versions 0+)","ref":"KlifeProtocol.Messages.EndQuorumEpoch.html#serialize_request/2","title":"KlifeProtocol.Messages.EndQuorumEpoch.serialize_request/2","type":"function"},{"doc":"Kafka protocol EndTxn message Request versions summary: Version 1 is the same as version 0. Version 2 adds the support for new error code PRODUCER_FENCED. Version 3 enables flexible versions. Response versions summary: Starting in version 1, on quota violation, brokers send out responses before throttling. Version 2 adds the support for new error code PRODUCER_FENCED. Version 3 enables flexible versions.","ref":"KlifeProtocol.Messages.EndTxn.html","title":"KlifeProtocol.Messages.EndTxn","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.EndTxn.html#api_key/0","title":"KlifeProtocol.Messages.EndTxn.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) error_code: The error code, or 0 if there was no error. (int16 | versions 0+)","ref":"KlifeProtocol.Messages.EndTxn.html#deserialize_response/3","title":"KlifeProtocol.Messages.EndTxn.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.EndTxn.html#max_supported_version/0","title":"KlifeProtocol.Messages.EndTxn.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.EndTxn.html#min_supported_version/0","title":"KlifeProtocol.Messages.EndTxn.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: transactional_id: The ID of the transaction to end. (string | versions 0+) producer_id: The producer ID. (int64 | versions 0+) producer_epoch: The current epoch associated with the producer. (int16 | versions 0+) committed: True if the transaction was committed, false if it was aborted. (bool | versions 0+)","ref":"KlifeProtocol.Messages.EndTxn.html#serialize_request/2","title":"KlifeProtocol.Messages.EndTxn.serialize_request/2","type":"function"},{"doc":"Kafka protocol Envelope message Request versions summary: Request struct for forwarding. Response versions summary: Response struct for forwarding.","ref":"KlifeProtocol.Messages.Envelope.html","title":"KlifeProtocol.Messages.Envelope","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.Envelope.html#api_key/0","title":"KlifeProtocol.Messages.Envelope.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: response_data: The embedded response header and data. (bytes | versions 0+) error_code: The error code, or 0 if there was no error. (int16 | versions 0+)","ref":"KlifeProtocol.Messages.Envelope.html#deserialize_response/3","title":"KlifeProtocol.Messages.Envelope.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.Envelope.html#max_supported_version/0","title":"KlifeProtocol.Messages.Envelope.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.Envelope.html#min_supported_version/0","title":"KlifeProtocol.Messages.Envelope.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: request_data: The embedded request header and data. (bytes | versions 0+) request_principal: Value of the initial client principal when the request is redirected by a broker. (bytes | versions 0+) client_host_address: The original client's address in bytes. (bytes | versions 0+)","ref":"KlifeProtocol.Messages.Envelope.html#serialize_request/2","title":"KlifeProtocol.Messages.Envelope.serialize_request/2","type":"function"},{"doc":"Kafka protocol ExpireDelegationToken message Request versions summary: Version 1 is the same as version 0. Version 2 adds flexible version support Response versions summary: Starting in version 1, on quota violation, brokers send out responses before throttling. Version 2 adds flexible version support","ref":"KlifeProtocol.Messages.ExpireDelegationToken.html","title":"KlifeProtocol.Messages.ExpireDelegationToken","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.ExpireDelegationToken.html#api_key/0","title":"KlifeProtocol.Messages.ExpireDelegationToken.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: error_code: The error code, or 0 if there was no error. (int16 | versions 0+) expiry_timestamp_ms: The timestamp in milliseconds at which this token expires. (int64 | versions 0+) throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+)","ref":"KlifeProtocol.Messages.ExpireDelegationToken.html#deserialize_response/3","title":"KlifeProtocol.Messages.ExpireDelegationToken.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.ExpireDelegationToken.html#max_supported_version/0","title":"KlifeProtocol.Messages.ExpireDelegationToken.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.ExpireDelegationToken.html#min_supported_version/0","title":"KlifeProtocol.Messages.ExpireDelegationToken.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: hmac: The HMAC of the delegation token to be expired. (bytes | versions 0+) expiry_time_period_ms: The expiry time period in milliseconds. (int64 | versions 0+)","ref":"KlifeProtocol.Messages.ExpireDelegationToken.html#serialize_request/2","title":"KlifeProtocol.Messages.ExpireDelegationToken.serialize_request/2","type":"function"},{"doc":"Kafka protocol Fetch message Request versions summary: Version 1 is the same as version 0. Starting in Version 2, the requestor must be able to handle Kafka Log Message format version 1. Version 3 adds MaxBytes. Starting in version 3, the partition ordering in the request is now relevant. Partitions will be processed in the order they appear in the request. Version 4 adds IsolationLevel. Starting in version 4, the reqestor must be able to handle Kafka log message format version 2. Version 5 adds LogStartOffset to indicate the earliest available offset of partition data that can be consumed. Version 6 is the same as version 5. Version 7 adds incremental fetch request support. Version 8 is the same as version 7. Version 9 adds CurrentLeaderEpoch, as described in KIP-320. Version 10 indicates that we can use the ZStd compression algorithm, as described in KIP-110. Version 12 adds flexible versions support as well as epoch validation through the LastFetchedEpoch field Version 13 replaces topic names with topic IDs (KIP-516). May return UNKNOWN_TOPIC_ID error code. Version 14 is the same as version 13 but it also receives a new error called OffsetMovedToTieredStorageException(KIP-405) Version 15 adds the ReplicaState which includes new field ReplicaEpoch and the ReplicaId. Also, deprecate the old ReplicaId field and set its default value to -1. (KIP-903) Response versions summary: Version 1 adds throttle time. Version 2 and 3 are the same as version 1. Version 4 adds features for transactional consumption. Version 5 adds LogStartOffset to indicate the earliest available offset of partition data that can be consumed. Starting in version 6, we may return KAFKA_STORAGE_ERROR as an error code. Version 7 adds incremental fetch request support. Starting in version 8, on quota violation, brokers send out responses before throttling. Version 9 is the same as version 8. Version 10 indicates that the response data can use the ZStd compression algorithm, as described in KIP-110. Version 12 adds support for flexible versions, epoch detection through the TruncationOffset field, and leader discovery through the CurrentLeader field Version 13 replaces the topic name field with topic ID (KIP-516). Version 14 is the same as version 13 but it also receives a new error called OffsetMovedToTieredStorageException (KIP-405) Version 15 is the same as version 14 (KIP-903).","ref":"KlifeProtocol.Messages.Fetch.html","title":"KlifeProtocol.Messages.Fetch","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.Fetch.html#api_key/0","title":"KlifeProtocol.Messages.Fetch.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 1+) error_code: The top level response error code. (int16 | versions 7+) session_id: The fetch session ID, or 0 if this is not part of a fetch session. (int32 | versions 7+) responses: The response topics. ([]FetchableTopicResponse | versions 0+) topic: The topic name. (string | versions 0-12) topic_id: The unique topic ID (uuid | versions 13+) partitions: The topic partitions. ([]PartitionData | versions 0+) partition_index: The partition index. (int32 | versions 0+) error_code: The error code, or 0 if there was no fetch error. (int16 | versions 0+) high_watermark: The current high water mark. (int64 | versions 0+) last_stable_offset: The last stable offset (or LSO) of the partition. This is the last offset such that the state of all transactional records prior to this offset have been decided (ABORTED or COMMITTED) (int64 | versions 4+) log_start_offset: The current log start offset. (int64 | versions 5+) diverging_epoch: In case divergence is detected based on the LastFetchedEpoch and FetchOffset in the request, this field indicates the largest epoch and its end offset such that subsequent records are known to diverge (EpochEndOffset | versions 12+) epoch: (int32 | versions 12+) end_offset: (int64 | versions 12+) current_leader: (LeaderIdAndEpoch | versions 12+) leader_id: The ID of the current leader or -1 if the leader is unknown. (int32 | versions 12+) leader_epoch: The latest known leader epoch (int32 | versions 12+) snapshot_id: In the case of fetching an offset less than the LogStartOffset, this is the end offset and epoch that should be used in the FetchSnapshot request. (SnapshotId | versions 12+) end_offset: (int64 | versions 0+) epoch: (int32 | versions 0+) aborted_transactions: The aborted transactions. ([]AbortedTransaction | versions 4+) producer_id: The producer id associated with the aborted transaction. (int64 | versions 4+) first_offset: The first offset in the aborted transaction. (int64 | versions 4+) preferred_read_replica: The preferred read replica for the consumer to use on its next fetch request (int32 | versions 11+) records: The record data. (records | versions 0+)","ref":"KlifeProtocol.Messages.Fetch.html#deserialize_response/3","title":"KlifeProtocol.Messages.Fetch.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.Fetch.html#max_supported_version/0","title":"KlifeProtocol.Messages.Fetch.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.Fetch.html#min_supported_version/0","title":"KlifeProtocol.Messages.Fetch.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: cluster_id: The clusterId if known. This is used to validate metadata fetches prior to broker registration. (string | versions 12+) replica_id: The broker ID of the follower, of -1 if this request is from a consumer. (int32 | versions 0-14) replica_state: (ReplicaState | versions 15+) replica_id: The replica ID of the follower, or -1 if this request is from a consumer. (int32 | versions 15+) replica_epoch: The epoch of this follower, or -1 if not available. (int64 | versions 15+) max_wait_ms: The maximum time in milliseconds to wait for the response. (int32 | versions 0+) min_bytes: The minimum bytes to accumulate in the response. (int32 | versions 0+) max_bytes: The maximum bytes to fetch. See KIP-74 for cases where this limit may not be honored. (int32 | versions 3+) isolation_level: This setting controls the visibility of transactional records. Using READ_UNCOMMITTED (isolation_level = 0) makes all records visible. With READ_COMMITTED (isolation_level = 1), non-transactional and COMMITTED transactional records are visible. To be more concrete, READ_COMMITTED returns all data from offsets smaller than the current LSO (last stable offset), and enables the inclusion of the list of aborted transactions in the result, which allows consumers to discard ABORTED transactional records (int8 | versions 4+) session_id: The fetch session ID. (int32 | versions 7+) session_epoch: The fetch session epoch, which is used for ordering requests in a session. (int32 | versions 7+) topics: The topics to fetch. ([]FetchTopic | versions 0+) topic: The name of the topic to fetch. (string | versions 0-12) topic_id: The unique topic ID (uuid | versions 13+) partitions: The partitions to fetch. ([]FetchPartition | versions 0+) partition: The partition index. (int32 | versions 0+) current_leader_epoch: The current leader epoch of the partition. (int32 | versions 9+) fetch_offset: The message offset. (int64 | versions 0+) last_fetched_epoch: The epoch of the last fetched record or -1 if there is none (int32 | versions 12+) log_start_offset: The earliest available offset of the follower replica. The field is only used when the request is sent by the follower. (int64 | versions 5+) partition_max_bytes: The maximum bytes to fetch from this partition. See KIP-74 for cases where this limit may not be honored. (int32 | versions 0+) forgotten_topics_data: In an incremental fetch request, the partitions to remove. ([]ForgottenTopic | versions 7+) topic: The topic name. (string | versions 7-12) topic_id: The unique topic ID (uuid | versions 13+) partitions: The partitions indexes to forget. ([]int32 | versions 7+) rack_id: Rack ID of the consumer making this request (string | versions 11+)","ref":"KlifeProtocol.Messages.Fetch.html#serialize_request/2","title":"KlifeProtocol.Messages.Fetch.serialize_request/2","type":"function"},{"doc":"Kafka protocol FetchSnapshot message Request versions summary: Response versions summary:","ref":"KlifeProtocol.Messages.FetchSnapshot.html","title":"KlifeProtocol.Messages.FetchSnapshot","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.FetchSnapshot.html#api_key/0","title":"KlifeProtocol.Messages.FetchSnapshot.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) error_code: The top level response error code. (int16 | versions 0+) topics: The topics to fetch. ([]TopicSnapshot | versions 0+) name: The name of the topic to fetch. (string | versions 0+) partitions: The partitions to fetch. ([]PartitionSnapshot | versions 0+) index: The partition index. (int32 | versions 0+) error_code: The error code, or 0 if there was no fetch error. (int16 | versions 0+) snapshot_id: The snapshot endOffset and epoch fetched (SnapshotId | versions 0+) end_offset: (int64 | versions 0+) epoch: (int32 | versions 0+) current_leader: (LeaderIdAndEpoch | versions 0+) leader_id: The ID of the current leader or -1 if the leader is unknown. (int32 | versions 0+) leader_epoch: The latest known leader epoch (int32 | versions 0+) size: The total size of the snapshot. (int64 | versions 0+) position: The starting byte position within the snapshot included in the Bytes field. (int64 | versions 0+) unaligned_records: Snapshot data in records format which may not be aligned on an offset boundary (records | versions 0+)","ref":"KlifeProtocol.Messages.FetchSnapshot.html#deserialize_response/3","title":"KlifeProtocol.Messages.FetchSnapshot.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.FetchSnapshot.html#max_supported_version/0","title":"KlifeProtocol.Messages.FetchSnapshot.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.FetchSnapshot.html#min_supported_version/0","title":"KlifeProtocol.Messages.FetchSnapshot.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: cluster_id: The clusterId if known, this is used to validate metadata fetches prior to broker registration (string | versions 0+) replica_id: The broker ID of the follower (int32 | versions 0+) max_bytes: The maximum bytes to fetch from all of the snapshots (int32 | versions 0+) topics: The topics to fetch ([]TopicSnapshot | versions 0+) name: The name of the topic to fetch (string | versions 0+) partitions: The partitions to fetch ([]PartitionSnapshot | versions 0+) partition: The partition index (int32 | versions 0+) current_leader_epoch: The current leader epoch of the partition, -1 for unknown leader epoch (int32 | versions 0+) snapshot_id: The snapshot endOffset and epoch to fetch (SnapshotId | versions 0+) end_offset: (int64 | versions 0+) epoch: (int32 | versions 0+) position: The byte position within the snapshot to start fetching from (int64 | versions 0+)","ref":"KlifeProtocol.Messages.FetchSnapshot.html#serialize_request/2","title":"KlifeProtocol.Messages.FetchSnapshot.serialize_request/2","type":"function"},{"doc":"Kafka protocol FindCoordinator message Request versions summary: Version 1 adds KeyType. Version 2 is the same as version 1. Version 3 is the first flexible version. Version 4 adds support for batching via CoordinatorKeys (KIP-699) Response versions summary: Version 1 adds throttle time and error messages. Starting in version 2, on quota violation, brokers send out responses before throttling. Version 3 is the first flexible version. Version 4 adds support for batching via Coordinators (KIP-699)","ref":"KlifeProtocol.Messages.FindCoordinator.html","title":"KlifeProtocol.Messages.FindCoordinator","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.FindCoordinator.html#api_key/0","title":"KlifeProtocol.Messages.FindCoordinator.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 1+) error_code: The error code, or 0 if there was no error. (int16 | versions 0-3) error_message: The error message, or null if there was no error. (string | versions 1-3) node_id: The node id. (int32 | versions 0-3) host: The host name. (string | versions 0-3) port: The port. (int32 | versions 0-3) coordinators: Each coordinator result in the response ([]Coordinator | versions 4+) key: The coordinator key. (string | versions 4+) node_id: The node id. (int32 | versions 4+) host: The host name. (string | versions 4+) port: The port. (int32 | versions 4+) error_code: The error code, or 0 if there was no error. (int16 | versions 4+) error_message: The error message, or null if there was no error. (string | versions 4+)","ref":"KlifeProtocol.Messages.FindCoordinator.html#deserialize_response/3","title":"KlifeProtocol.Messages.FindCoordinator.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.FindCoordinator.html#max_supported_version/0","title":"KlifeProtocol.Messages.FindCoordinator.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.FindCoordinator.html#min_supported_version/0","title":"KlifeProtocol.Messages.FindCoordinator.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: key: The coordinator key. (string | versions 0-3) key_type: The coordinator key type. (Group, transaction, etc.) (int8 | versions 1+) coordinator_keys: The coordinator keys. ([]string | versions 4+)","ref":"KlifeProtocol.Messages.FindCoordinator.html#serialize_request/2","title":"KlifeProtocol.Messages.FindCoordinator.serialize_request/2","type":"function"},{"doc":"Kafka protocol Heartbeat message Request versions summary: Version 1 and version 2 are the same as version 0. Starting from version 3, we add a new field called groupInstanceId to indicate member identity across restarts. Version 4 is the first flexible version. Response versions summary: Version 1 adds throttle time. Starting in version 2, on quota violation, brokers send out responses before throttling. Starting from version 3, heartbeatRequest supports a new field called groupInstanceId to indicate member identity across restarts. Version 4 is the first flexible version.","ref":"KlifeProtocol.Messages.Heartbeat.html","title":"KlifeProtocol.Messages.Heartbeat","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.Heartbeat.html#api_key/0","title":"KlifeProtocol.Messages.Heartbeat.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 1+) error_code: The error code, or 0 if there was no error. (int16 | versions 0+)","ref":"KlifeProtocol.Messages.Heartbeat.html#deserialize_response/3","title":"KlifeProtocol.Messages.Heartbeat.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.Heartbeat.html#max_supported_version/0","title":"KlifeProtocol.Messages.Heartbeat.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.Heartbeat.html#min_supported_version/0","title":"KlifeProtocol.Messages.Heartbeat.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: group_id: The group id. (string | versions 0+) generation_id: The generation of the group. (int32 | versions 0+) member_id: The member ID. (string | versions 0+) group_instance_id: The unique identifier of the consumer instance provided by end user. (string | versions 3+)","ref":"KlifeProtocol.Messages.Heartbeat.html#serialize_request/2","title":"KlifeProtocol.Messages.Heartbeat.serialize_request/2","type":"function"},{"doc":"Kafka protocol IncrementalAlterConfigs message Request versions summary: Version 1 is the first flexible version. Response versions summary: Version 1 is the first flexible version.","ref":"KlifeProtocol.Messages.IncrementalAlterConfigs.html","title":"KlifeProtocol.Messages.IncrementalAlterConfigs","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.IncrementalAlterConfigs.html#api_key/0","title":"KlifeProtocol.Messages.IncrementalAlterConfigs.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: Duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) responses: The responses for each resource. ([]AlterConfigsResourceResponse | versions 0+) error_code: The resource error code. (int16 | versions 0+) error_message: The resource error message, or null if there was no error. (string | versions 0+) resource_type: The resource type. (int8 | versions 0+) resource_name: The resource name. (string | versions 0+)","ref":"KlifeProtocol.Messages.IncrementalAlterConfigs.html#deserialize_response/3","title":"KlifeProtocol.Messages.IncrementalAlterConfigs.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.IncrementalAlterConfigs.html#max_supported_version/0","title":"KlifeProtocol.Messages.IncrementalAlterConfigs.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.IncrementalAlterConfigs.html#min_supported_version/0","title":"KlifeProtocol.Messages.IncrementalAlterConfigs.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: resources: The incremental updates for each resource. ([]AlterConfigsResource | versions 0+) resource_type: The resource type. (int8 | versions 0+) resource_name: The resource name. (string | versions 0+) configs: The configurations. ([]AlterableConfig | versions 0+) name: The configuration key name. (string | versions 0+) config_operation: The type (Set, Delete, Append, Subtract) of operation. (int8 | versions 0+) value: The value to set for the configuration key. (string | versions 0+) validate_only: True if we should validate the request, but not change the configurations. (bool | versions 0+)","ref":"KlifeProtocol.Messages.IncrementalAlterConfigs.html#serialize_request/2","title":"KlifeProtocol.Messages.IncrementalAlterConfigs.serialize_request/2","type":"function"},{"doc":"Kafka protocol InitProducerId message Request versions summary: Version 1 is the same as version 0. Version 2 is the first flexible version. Version 3 adds ProducerId and ProducerEpoch, allowing producers to try to resume after an INVALID_PRODUCER_EPOCH error Version 4 adds the support for new error code PRODUCER_FENCED. Response versions summary: Starting in version 1, on quota violation, brokers send out responses before throttling. Version 2 is the first flexible version. Version 3 is the same as version 2. Version 4 adds the support for new error code PRODUCER_FENCED.","ref":"KlifeProtocol.Messages.InitProducerId.html","title":"KlifeProtocol.Messages.InitProducerId","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.InitProducerId.html#api_key/0","title":"KlifeProtocol.Messages.InitProducerId.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) error_code: The error code, or 0 if there was no error. (int16 | versions 0+) producer_id: The current producer id. (int64 | versions 0+) producer_epoch: The current epoch associated with the producer id. (int16 | versions 0+)","ref":"KlifeProtocol.Messages.InitProducerId.html#deserialize_response/3","title":"KlifeProtocol.Messages.InitProducerId.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.InitProducerId.html#max_supported_version/0","title":"KlifeProtocol.Messages.InitProducerId.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.InitProducerId.html#min_supported_version/0","title":"KlifeProtocol.Messages.InitProducerId.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: transactional_id: The transactional id, or null if the producer is not transactional. (string | versions 0+) transaction_timeout_ms: The time in ms to wait before aborting idle transactions sent by this producer. This is only relevant if a TransactionalId has been defined. (int32 | versions 0+) producer_id: The producer id. This is used to disambiguate requests if a transactional id is reused following its expiration. (int64 | versions 3+) producer_epoch: The producer's current epoch. This will be checked against the producer epoch on the broker, and the request will return an error if they do not match. (int16 | versions 3+)","ref":"KlifeProtocol.Messages.InitProducerId.html#serialize_request/2","title":"KlifeProtocol.Messages.InitProducerId.serialize_request/2","type":"function"},{"doc":"Kafka protocol JoinGroup message Request versions summary: Version 1 adds RebalanceTimeoutMs. Version 2 and 3 are the same as version 1. Starting from version 4, the client needs to issue a second request to join group Starting from version 5, we add a new field called groupInstanceId to indicate member identity across restarts. with assigned id. Version 6 is the first flexible version. Version 7 is the same as version 6. Version 8 adds the Reason field (KIP-800). Version 9 is the same as version 8. Response versions summary: Version 1 is the same as version 0. Version 2 adds throttle time. Starting in version 3, on quota violation, brokers send out responses before throttling. Starting in version 4, the client needs to issue a second request to join group with assigned id. Version 5 is bumped to apply group.instance.id to identify member across restarts. Version 6 is the first flexible version. Starting from version 7, the broker sends back the Protocol Type to the client (KIP-559). Version 8 is the same as version 7. Version 9 adds the SkipAssignment field.","ref":"KlifeProtocol.Messages.JoinGroup.html","title":"KlifeProtocol.Messages.JoinGroup","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.JoinGroup.html#api_key/0","title":"KlifeProtocol.Messages.JoinGroup.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 2+) error_code: The error code, or 0 if there was no error. (int16 | versions 0+) generation_id: The generation ID of the group. (int32 | versions 0+) protocol_type: The group protocol name. (string | versions 7+) protocol_name: The group protocol selected by the coordinator. (string | versions 0+) leader: The leader of the group. (string | versions 0+) skip_assignment: True if the leader must skip running the assignment. (bool | versions 9+) member_id: The member ID assigned by the group coordinator. (string | versions 0+) members: ([]JoinGroupResponseMember | versions 0+) member_id: The group member ID. (string | versions 0+) group_instance_id: The unique identifier of the consumer instance provided by end user. (string | versions 5+) metadata: The group member metadata. (bytes | versions 0+)","ref":"KlifeProtocol.Messages.JoinGroup.html#deserialize_response/3","title":"KlifeProtocol.Messages.JoinGroup.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.JoinGroup.html#max_supported_version/0","title":"KlifeProtocol.Messages.JoinGroup.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.JoinGroup.html#min_supported_version/0","title":"KlifeProtocol.Messages.JoinGroup.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: group_id: The group identifier. (string | versions 0+) session_timeout_ms: The coordinator considers the consumer dead if it receives no heartbeat after this timeout in milliseconds. (int32 | versions 0+) rebalance_timeout_ms: The maximum time in milliseconds that the coordinator will wait for each member to rejoin when rebalancing the group. (int32 | versions 1+) member_id: The member id assigned by the group coordinator. (string | versions 0+) group_instance_id: The unique identifier of the consumer instance provided by end user. (string | versions 5+) protocol_type: The unique name the for class of protocols implemented by the group we want to join. (string | versions 0+) protocols: The list of protocols that the member supports. ([]JoinGroupRequestProtocol | versions 0+) name: The protocol name. (string | versions 0+) metadata: The protocol metadata. (bytes | versions 0+) reason: The reason why the member (re-)joins the group. (string | versions 8+)","ref":"KlifeProtocol.Messages.JoinGroup.html#serialize_request/2","title":"KlifeProtocol.Messages.JoinGroup.serialize_request/2","type":"function"},{"doc":"Kafka protocol LeaderAndIsr message Request versions summary: Version 1 adds IsNew. Version 2 adds broker epoch and reorganizes the partitions by topic. Version 3 adds AddingReplicas and RemovingReplicas. Version 4 is the first flexible version. Version 5 adds Topic ID and Type to the TopicStates, as described in KIP-516. Version 6 adds LeaderRecoveryState as described in KIP-704. Version 7 adds KRaft Controller ID field as part of KIP-866 Response versions summary: Version 1 adds KAFKA_STORAGE_ERROR as a valid error code. Version 2 is the same as version 1. Version 3 is the same as version 2. Version 4 is the first flexible version. Version 5 removes TopicName and replaces it with TopicId and reorganizes the partitions by topic, as described by KIP-516.","ref":"KlifeProtocol.Messages.LeaderAndIsr.html","title":"KlifeProtocol.Messages.LeaderAndIsr","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.LeaderAndIsr.html#api_key/0","title":"KlifeProtocol.Messages.LeaderAndIsr.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: error_code: The error code, or 0 if there was no error. (int16 | versions 0+) partition_errors: Each partition in v0 to v4 message. ([]LeaderAndIsrPartitionError | versions 0-4) topic_name: The topic name. (string | versions 0-4) partition_index: The partition index. (int32 | versions 0+) error_code: The partition error code, or 0 if there was no error. (int16 | versions 0+) topics: Each topic ([]LeaderAndIsrTopicError | versions 5+) topic_id: The unique topic ID (uuid | versions 5+) partition_errors: Each partition. ([]LeaderAndIsrPartitionError | versions 5+) topic_name: The topic name. (string | versions 0-4) partition_index: The partition index. (int32 | versions 0+) error_code: The partition error code, or 0 if there was no error. (int16 | versions 0+)","ref":"KlifeProtocol.Messages.LeaderAndIsr.html#deserialize_response/3","title":"KlifeProtocol.Messages.LeaderAndIsr.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.LeaderAndIsr.html#max_supported_version/0","title":"KlifeProtocol.Messages.LeaderAndIsr.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.LeaderAndIsr.html#min_supported_version/0","title":"KlifeProtocol.Messages.LeaderAndIsr.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: controller_id: The current controller ID. (int32 | versions 0+) is_k_raft_controller: If KRaft controller id is used during migration. See KIP-866 (bool | versions 7+) controller_epoch: The current controller epoch. (int32 | versions 0+) broker_epoch: The current broker epoch. (int64 | versions 2+) type: The type that indicates whether all topics are included in the request (int8 | versions 5+) ungrouped_partition_states: The state of each partition, in a v0 or v1 message. ([]LeaderAndIsrPartitionState | versions 0-1) topic_name: The topic name. This is only present in v0 or v1. (string | versions 0-1) partition_index: The partition index. (int32 | versions 0+) controller_epoch: The controller epoch. (int32 | versions 0+) leader: The broker ID of the leader. (int32 | versions 0+) leader_epoch: The leader epoch. (int32 | versions 0+) isr: The in-sync replica IDs. ([]int32 | versions 0+) partition_epoch: The current epoch for the partition. The epoch is a monotonically increasing value which is incremented after every partition change. (Since the LeaderAndIsr request is only used by the legacy controller, this corresponds to the zkVersion) (int32 | versions 0+) replicas: The replica IDs. ([]int32 | versions 0+) adding_replicas: The replica IDs that we are adding this partition to, or null if no replicas are being added. ([]int32 | versions 3+) removing_replicas: The replica IDs that we are removing this partition from, or null if no replicas are being removed. ([]int32 | versions 3+) is_new: Whether the replica should have existed on the broker or not. (bool | versions 1+) leader_recovery_state: 1 if the partition is recovering from an unclean leader election; 0 otherwise. (int8 | versions 6+) topic_states: Each topic. ([]LeaderAndIsrTopicState | versions 2+) topic_name: The topic name. (string | versions 2+) topic_id: The unique topic ID. (uuid | versions 5+) partition_states: The state of each partition ([]LeaderAndIsrPartitionState | versions 2+) topic_name: The topic name. This is only present in v0 or v1. (string | versions 0-1) partition_index: The partition index. (int32 | versions 0+) controller_epoch: The controller epoch. (int32 | versions 0+) leader: The broker ID of the leader. (int32 | versions 0+) leader_epoch: The leader epoch. (int32 | versions 0+) isr: The in-sync replica IDs. ([]int32 | versions 0+) partition_epoch: The current epoch for the partition. The epoch is a monotonically increasing value which is incremented after every partition change. (Since the LeaderAndIsr request is only used by the legacy controller, this corresponds to the zkVersion) (int32 | versions 0+) replicas: The replica IDs. ([]int32 | versions 0+) adding_replicas: The replica IDs that we are adding this partition to, or null if no replicas are being added. ([]int32 | versions 3+) removing_replicas: The replica IDs that we are removing this partition from, or null if no replicas are being removed. ([]int32 | versions 3+) is_new: Whether the replica should have existed on the broker or not. (bool | versions 1+) leader_recovery_state: 1 if the partition is recovering from an unclean leader election; 0 otherwise. (int8 | versions 6+) live_leaders: The current live leaders. ([]LeaderAndIsrLiveLeader | versions 0+) broker_id: The leader's broker ID. (int32 | versions 0+) host_name: The leader's hostname. (string | versions 0+) port: The leader's port. (int32 | versions 0+)","ref":"KlifeProtocol.Messages.LeaderAndIsr.html#serialize_request/2","title":"KlifeProtocol.Messages.LeaderAndIsr.serialize_request/2","type":"function"},{"doc":"Kafka protocol LeaveGroup message Request versions summary: Version 1 and 2 are the same as version 0. Version 3 defines batch processing scheme with group.instance.id + member.id for identity Version 4 is the first flexible version. Version 5 adds the Reason field (KIP-800). Response versions summary: Version 1 adds the throttle time. Starting in version 2, on quota violation, brokers send out responses before throttling. Starting in version 3, we will make leave group request into batch mode and add group.instance.id. Version 4 is the first flexible version. Version 5 is the same as version 4.","ref":"KlifeProtocol.Messages.LeaveGroup.html","title":"KlifeProtocol.Messages.LeaveGroup","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.LeaveGroup.html#api_key/0","title":"KlifeProtocol.Messages.LeaveGroup.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 1+) error_code: The error code, or 0 if there was no error. (int16 | versions 0+) members: List of leaving member responses. ([]MemberResponse | versions 3+) member_id: The member ID to remove from the group. (string | versions 3+) group_instance_id: The group instance ID to remove from the group. (string | versions 3+) error_code: The error code, or 0 if there was no error. (int16 | versions 3+)","ref":"KlifeProtocol.Messages.LeaveGroup.html#deserialize_response/3","title":"KlifeProtocol.Messages.LeaveGroup.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.LeaveGroup.html#max_supported_version/0","title":"KlifeProtocol.Messages.LeaveGroup.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.LeaveGroup.html#min_supported_version/0","title":"KlifeProtocol.Messages.LeaveGroup.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: group_id: The ID of the group to leave. (string | versions 0+) member_id: The member ID to remove from the group. (string | versions 0-2) members: List of leaving member identities. ([]MemberIdentity | versions 3+) member_id: The member ID to remove from the group. (string | versions 3+) group_instance_id: The group instance ID to remove from the group. (string | versions 3+) reason: The reason why the member left the group. (string | versions 5+)","ref":"KlifeProtocol.Messages.LeaveGroup.html#serialize_request/2","title":"KlifeProtocol.Messages.LeaveGroup.serialize_request/2","type":"function"},{"doc":"Kafka protocol ListGroups message Request versions summary: Version 1 and 2 are the same as version 0. Version 3 is the first flexible version. Version 4 adds the StatesFilter field (KIP-518). Response versions summary: Version 1 adds the throttle time. Starting in version 2, on quota violation, brokers send out responses before throttling. Version 3 is the first flexible version. Version 4 adds the GroupState field (KIP-518).","ref":"KlifeProtocol.Messages.ListGroups.html","title":"KlifeProtocol.Messages.ListGroups","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.ListGroups.html#api_key/0","title":"KlifeProtocol.Messages.ListGroups.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 1+) error_code: The error code, or 0 if there was no error. (int16 | versions 0+) groups: Each group in the response. ([]ListedGroup | versions 0+) group_id: The group ID. (string | versions 0+) protocol_type: The group protocol type. (string | versions 0+) group_state: The group state name. (string | versions 4+)","ref":"KlifeProtocol.Messages.ListGroups.html#deserialize_response/3","title":"KlifeProtocol.Messages.ListGroups.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.ListGroups.html#max_supported_version/0","title":"KlifeProtocol.Messages.ListGroups.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.ListGroups.html#min_supported_version/0","title":"KlifeProtocol.Messages.ListGroups.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: states_filter: The states of the groups we want to list. If empty all groups are returned with their state. ([]string | versions 4+)","ref":"KlifeProtocol.Messages.ListGroups.html#serialize_request/2","title":"KlifeProtocol.Messages.ListGroups.serialize_request/2","type":"function"},{"doc":"Kafka protocol ListOffsets message Request versions summary: Version 1 removes MaxNumOffsets. From this version forward, only a single offset can be returned. Version 2 adds the isolation level, which is used for transactional reads. Version 3 is the same as version 2. Version 4 adds the current leader epoch, which is used for fencing. Version 5 is the same as version 4. Version 6 enables flexible versions. Version 7 enables listing offsets by max timestamp (KIP-734). Version 8 enables listing offsets by local log start offset (KIP-405). Response versions summary: Version 1 removes the offsets array in favor of returning a single offset. Version 1 also adds the timestamp associated with the returned offset. Version 2 adds the throttle time. Starting in version 3, on quota violation, brokers send out responses before throttling. Version 4 adds the leader epoch, which is used for fencing. Version 5 adds a new error code, OFFSET_NOT_AVAILABLE. Version 6 enables flexible versions. Version 7 is the same as version 6 (KIP-734). Version 8 enables listing offsets by local log start offset. This is the ealiest log start offset in the local log. (KIP-405).","ref":"KlifeProtocol.Messages.ListOffsets.html","title":"KlifeProtocol.Messages.ListOffsets","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.ListOffsets.html#api_key/0","title":"KlifeProtocol.Messages.ListOffsets.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 2+) topics: Each topic in the response. ([]ListOffsetsTopicResponse | versions 0+) name: The topic name (string | versions 0+) partitions: Each partition in the response. ([]ListOffsetsPartitionResponse | versions 0+) partition_index: The partition index. (int32 | versions 0+) error_code: The partition error code, or 0 if there was no error. (int16 | versions 0+) old_style_offsets: The result offsets. ([]int64 | versions 0) timestamp: The timestamp associated with the returned offset. (int64 | versions 1+) offset: The returned offset. (int64 | versions 1+) leader_epoch: (int32 | versions 4+)","ref":"KlifeProtocol.Messages.ListOffsets.html#deserialize_response/3","title":"KlifeProtocol.Messages.ListOffsets.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.ListOffsets.html#max_supported_version/0","title":"KlifeProtocol.Messages.ListOffsets.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.ListOffsets.html#min_supported_version/0","title":"KlifeProtocol.Messages.ListOffsets.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: replica_id: The broker ID of the requestor, or -1 if this request is being made by a normal consumer. (int32 | versions 0+) isolation_level: This setting controls the visibility of transactional records. Using READ_UNCOMMITTED (isolation_level = 0) makes all records visible. With READ_COMMITTED (isolation_level = 1), non-transactional and COMMITTED transactional records are visible. To be more concrete, READ_COMMITTED returns all data from offsets smaller than the current LSO (last stable offset), and enables the inclusion of the list of aborted transactions in the result, which allows consumers to discard ABORTED transactional records (int8 | versions 2+) topics: Each topic in the request. ([]ListOffsetsTopic | versions 0+) name: The topic name. (string | versions 0+) partitions: Each partition in the request. ([]ListOffsetsPartition | versions 0+) partition_index: The partition index. (int32 | versions 0+) current_leader_epoch: The current leader epoch. (int32 | versions 4+) timestamp: The current timestamp. (int64 | versions 0+) max_num_offsets: The maximum number of offsets to report. (int32 | versions 0)","ref":"KlifeProtocol.Messages.ListOffsets.html#serialize_request/2","title":"KlifeProtocol.Messages.ListOffsets.serialize_request/2","type":"function"},{"doc":"Kafka protocol ListPartitionReassignments message Request versions summary: Response versions summary:","ref":"KlifeProtocol.Messages.ListPartitionReassignments.html","title":"KlifeProtocol.Messages.ListPartitionReassignments","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.ListPartitionReassignments.html#api_key/0","title":"KlifeProtocol.Messages.ListPartitionReassignments.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) error_code: The top-level error code, or 0 if there was no error (int16 | versions 0+) error_message: The top-level error message, or null if there was no error. (string | versions 0+) topics: The ongoing reassignments for each topic. ([]OngoingTopicReassignment | versions 0+) name: The topic name. (string | versions 0+) partitions: The ongoing reassignments for each partition. ([]OngoingPartitionReassignment | versions 0+) partition_index: The index of the partition. (int32 | versions 0+) replicas: The current replica set. ([]int32 | versions 0+) adding_replicas: The set of replicas we are currently adding. ([]int32 | versions 0+) removing_replicas: The set of replicas we are currently removing. ([]int32 | versions 0+)","ref":"KlifeProtocol.Messages.ListPartitionReassignments.html#deserialize_response/3","title":"KlifeProtocol.Messages.ListPartitionReassignments.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.ListPartitionReassignments.html#max_supported_version/0","title":"KlifeProtocol.Messages.ListPartitionReassignments.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.ListPartitionReassignments.html#min_supported_version/0","title":"KlifeProtocol.Messages.ListPartitionReassignments.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: timeout_ms: The time in ms to wait for the request to complete. (int32 | versions 0+) topics: The topics to list partition reassignments for, or null to list everything. ([]ListPartitionReassignmentsTopics | versions 0+) name: The topic name (string | versions 0+) partition_indexes: The partitions to list partition reassignments for. ([]int32 | versions 0+)","ref":"KlifeProtocol.Messages.ListPartitionReassignments.html#serialize_request/2","title":"KlifeProtocol.Messages.ListPartitionReassignments.serialize_request/2","type":"function"},{"doc":"Kafka protocol ListTransactions message Request versions summary: Response versions summary:","ref":"KlifeProtocol.Messages.ListTransactions.html","title":"KlifeProtocol.Messages.ListTransactions","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.ListTransactions.html#api_key/0","title":"KlifeProtocol.Messages.ListTransactions.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) error_code: (int16 | versions 0+) unknown_state_filters: Set of state filters provided in the request which were unknown to the transaction coordinator ([]string | versions 0+) transaction_states: ([]TransactionState | versions 0+) transactional_id: (string | versions 0+) producer_id: (int64 | versions 0+) transaction_state: The current transaction state of the producer (string | versions 0+)","ref":"KlifeProtocol.Messages.ListTransactions.html#deserialize_response/3","title":"KlifeProtocol.Messages.ListTransactions.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.ListTransactions.html#max_supported_version/0","title":"KlifeProtocol.Messages.ListTransactions.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.ListTransactions.html#min_supported_version/0","title":"KlifeProtocol.Messages.ListTransactions.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: state_filters: The transaction states to filter by: if empty, all transactions are returned; if non-empty, then only transactions matching one of the filtered states will be returned ([]string | versions 0+) producer_id_filters: The producerIds to filter by: if empty, all transactions will be returned; if non-empty, only transactions which match one of the filtered producerIds will be returned ([]int64 | versions 0+)","ref":"KlifeProtocol.Messages.ListTransactions.html#serialize_request/2","title":"KlifeProtocol.Messages.ListTransactions.serialize_request/2","type":"function"},{"doc":"Kafka protocol Metadata message Request versions summary: Response versions summary: Version 1 adds fields for the rack of each broker, the controller id, and whether or not the topic is internal. Version 2 adds the cluster ID field. Version 3 adds the throttle time. Version 4 is the same as version 3. Version 5 adds a per-partition offline_replicas field. This field specifies the list of replicas that are offline. Starting in version 6, on quota violation, brokers send out responses before throttling. Version 7 adds the leader epoch to the partition metadata. Starting in version 8, brokers can send authorized operations for topic and cluster. Version 9 is the first flexible version. Version 10 adds topicId. Version 11 deprecates ClusterAuthorizedOperations. This is now exposed by the DescribeCluster API (KIP-700). Version 12 supports topicId.","ref":"KlifeProtocol.Messages.Metadata.html","title":"KlifeProtocol.Messages.Metadata","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.Metadata.html#api_key/0","title":"KlifeProtocol.Messages.Metadata.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 3+) brokers: Each broker in the response. ([]MetadataResponseBroker | versions 0+) node_id: The broker ID. (int32 | versions 0+) host: The broker hostname. (string | versions 0+) port: The broker port. (int32 | versions 0+) rack: The rack of the broker, or null if it has not been assigned to a rack. (string | versions 1+) cluster_id: The cluster ID that responding broker belongs to. (string | versions 2+) controller_id: The ID of the controller broker. (int32 | versions 1+) topics: Each topic in the response. ([]MetadataResponseTopic | versions 0+) error_code: The topic error, or 0 if there was no error. (int16 | versions 0+) name: The topic name. (string | versions 0+) topic_id: The topic id. (uuid | versions 10+) is_internal: True if the topic is internal. (bool | versions 1+) partitions: Each partition in the topic. ([]MetadataResponsePartition | versions 0+) error_code: The partition error, or 0 if there was no error. (int16 | versions 0+) partition_index: The partition index. (int32 | versions 0+) leader_id: The ID of the leader broker. (int32 | versions 0+) leader_epoch: The leader epoch of this partition. (int32 | versions 7+) replica_nodes: The set of all nodes that host this partition. ([]int32 | versions 0+) isr_nodes: The set of nodes that are in sync with the leader for this partition. ([]int32 | versions 0+) offline_replicas: The set of offline replicas of this partition. ([]int32 | versions 5+) topic_authorized_operations: 32-bit bitfield to represent authorized operations for this topic. (int32 | versions 8+) cluster_authorized_operations: 32-bit bitfield to represent authorized operations for this cluster. (int32 | versions 8-10)","ref":"KlifeProtocol.Messages.Metadata.html#deserialize_response/3","title":"KlifeProtocol.Messages.Metadata.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.Metadata.html#max_supported_version/0","title":"KlifeProtocol.Messages.Metadata.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.Metadata.html#min_supported_version/0","title":"KlifeProtocol.Messages.Metadata.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: topics: The topics to fetch metadata for. ([]MetadataRequestTopic | versions 0+) topic_id: The topic id. (uuid | versions 10+) name: The topic name. (string | versions 0+) allow_auto_topic_creation: If this is true, the broker may auto-create topics that we requested which do not already exist, if it is configured to do so. (bool | versions 4+) include_cluster_authorized_operations: Whether to include cluster authorized operations. (bool | versions 8-10) include_topic_authorized_operations: Whether to include topic authorized operations. (bool | versions 8+)","ref":"KlifeProtocol.Messages.Metadata.html#serialize_request/2","title":"KlifeProtocol.Messages.Metadata.serialize_request/2","type":"function"},{"doc":"Kafka protocol OffsetCommit message Request versions summary: Version 1 adds timestamp and group membership information, as well as the commit timestamp. Version 2 adds retention time. It removes the commit timestamp added in version 1. Version 3 and 4 are the same as version 2. Version 5 removes the retention time, which is now controlled only by a broker configuration. Version 6 adds the leader epoch for fencing. version 7 adds a new field called groupInstanceId to indicate member identity across restarts. Version 8 is the first flexible version. Response versions summary: Versions 1 and 2 are the same as version 0. Version 3 adds the throttle time to the response. Starting in version 4, on quota violation, brokers send out responses before throttling. Versions 5 and 6 are the same as version 4. Version 7 offsetCommitRequest supports a new field called groupInstanceId to indicate member identity across restarts. Version 8 is the first flexible version.","ref":"KlifeProtocol.Messages.OffsetCommit.html","title":"KlifeProtocol.Messages.OffsetCommit","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.OffsetCommit.html#api_key/0","title":"KlifeProtocol.Messages.OffsetCommit.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 3+) topics: The responses for each topic. ([]OffsetCommitResponseTopic | versions 0+) name: The topic name. (string | versions 0+) partitions: The responses for each partition in the topic. ([]OffsetCommitResponsePartition | versions 0+) partition_index: The partition index. (int32 | versions 0+) error_code: The error code, or 0 if there was no error. (int16 | versions 0+)","ref":"KlifeProtocol.Messages.OffsetCommit.html#deserialize_response/3","title":"KlifeProtocol.Messages.OffsetCommit.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.OffsetCommit.html#max_supported_version/0","title":"KlifeProtocol.Messages.OffsetCommit.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.OffsetCommit.html#min_supported_version/0","title":"KlifeProtocol.Messages.OffsetCommit.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: group_id: The unique group identifier. (string | versions 0+) generation_id: The generation of the group. (int32 | versions 1+) member_id: The member ID assigned by the group coordinator. (string | versions 1+) group_instance_id: The unique identifier of the consumer instance provided by end user. (string | versions 7+) retention_time_ms: The time period in ms to retain the offset. (int64 | versions 2-4) topics: The topics to commit offsets for. ([]OffsetCommitRequestTopic | versions 0+) name: The topic name. (string | versions 0+) partitions: Each partition to commit offsets for. ([]OffsetCommitRequestPartition | versions 0+) partition_index: The partition index. (int32 | versions 0+) committed_offset: The message offset to be committed. (int64 | versions 0+) committed_leader_epoch: The leader epoch of this partition. (int32 | versions 6+) commit_timestamp: The timestamp of the commit. (int64 | versions 1) committed_metadata: Any associated metadata the client wants to keep. (string | versions 0+)","ref":"KlifeProtocol.Messages.OffsetCommit.html#serialize_request/2","title":"KlifeProtocol.Messages.OffsetCommit.serialize_request/2","type":"function"},{"doc":"Kafka protocol OffsetDelete message Request versions summary: Response versions summary:","ref":"KlifeProtocol.Messages.OffsetDelete.html","title":"KlifeProtocol.Messages.OffsetDelete","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.OffsetDelete.html#api_key/0","title":"KlifeProtocol.Messages.OffsetDelete.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: error_code: The top-level error code, or 0 if there was no error. (int16 | versions 0+) throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) topics: The responses for each topic. ([]OffsetDeleteResponseTopic | versions 0+) name: The topic name. (string | versions 0+) partitions: The responses for each partition in the topic. ([]OffsetDeleteResponsePartition | versions 0+) partition_index: The partition index. (int32 | versions 0+) error_code: The error code, or 0 if there was no error. (int16 | versions 0+)","ref":"KlifeProtocol.Messages.OffsetDelete.html#deserialize_response/3","title":"KlifeProtocol.Messages.OffsetDelete.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.OffsetDelete.html#max_supported_version/0","title":"KlifeProtocol.Messages.OffsetDelete.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.OffsetDelete.html#min_supported_version/0","title":"KlifeProtocol.Messages.OffsetDelete.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: group_id: The unique group identifier. (string | versions 0+) topics: The topics to delete offsets for ([]OffsetDeleteRequestTopic | versions 0+) name: The topic name. (string | versions 0+) partitions: Each partition to delete offsets for. ([]OffsetDeleteRequestPartition | versions 0+) partition_index: The partition index. (int32 | versions 0+)","ref":"KlifeProtocol.Messages.OffsetDelete.html#serialize_request/2","title":"KlifeProtocol.Messages.OffsetDelete.serialize_request/2","type":"function"},{"doc":"Kafka protocol OffsetFetch message Request versions summary: In version 0, the request read offsets from ZK. Starting in version 1, the broker supports fetching offsets from the internal __consumer_offsets topic. Starting in version 2, the request can contain a null topics array to indicate that offsets for all topics should be fetched. It also returns a top level error code for group or coordinator level errors. Version 3, 4, and 5 are the same as version 2. Version 6 is the first flexible version. Version 7 is adding the require stable flag. Version 8 is adding support for fetching offsets for multiple groups at a time Response versions summary: Version 1 is the same as version 0. Version 2 adds a top-level error code. Version 3 adds the throttle time. Starting in version 4, on quota violation, brokers send out responses before throttling. Version 5 adds the leader epoch to the committed offset. Version 6 is the first flexible version. Version 7 adds pending offset commit as new error response on partition level. Version 8 is adding support for fetching offsets for multiple groups","ref":"KlifeProtocol.Messages.OffsetFetch.html","title":"KlifeProtocol.Messages.OffsetFetch","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.OffsetFetch.html#api_key/0","title":"KlifeProtocol.Messages.OffsetFetch.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 3+) topics: The responses per topic. ([]OffsetFetchResponseTopic | versions 0-7) name: The topic name. (string | versions 0-7) partitions: The responses per partition ([]OffsetFetchResponsePartition | versions 0-7) partition_index: The partition index. (int32 | versions 0-7) committed_offset: The committed message offset. (int64 | versions 0-7) committed_leader_epoch: The leader epoch. (int32 | versions 5-7) metadata: The partition metadata. (string | versions 0-7) error_code: The error code, or 0 if there was no error. (int16 | versions 0-7) error_code: The top-level error code, or 0 if there was no error. (int16 | versions 2-7) groups: The responses per group id. ([]OffsetFetchResponseGroup | versions 8+) group_id: The group ID. (string | versions 8+) topics: The responses per topic. ([]OffsetFetchResponseTopics | versions 8+) name: The topic name. (string | versions 8+) partitions: The responses per partition ([]OffsetFetchResponsePartitions | versions 8+) partition_index: The partition index. (int32 | versions 8+) committed_offset: The committed message offset. (int64 | versions 8+) committed_leader_epoch: The leader epoch. (int32 | versions 8+) metadata: The partition metadata. (string | versions 8+) error_code: The partition-level error code, or 0 if there was no error. (int16 | versions 8+) error_code: The group-level error code, or 0 if there was no error. (int16 | versions 8+)","ref":"KlifeProtocol.Messages.OffsetFetch.html#deserialize_response/3","title":"KlifeProtocol.Messages.OffsetFetch.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.OffsetFetch.html#max_supported_version/0","title":"KlifeProtocol.Messages.OffsetFetch.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.OffsetFetch.html#min_supported_version/0","title":"KlifeProtocol.Messages.OffsetFetch.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: group_id: The group to fetch offsets for. (string | versions 0-7) topics: Each topic we would like to fetch offsets for, or null to fetch offsets for all topics. ([]OffsetFetchRequestTopic | versions 0-7) name: The topic name. (string | versions 0-7) partition_indexes: The partition indexes we would like to fetch offsets for. ([]int32 | versions 0-7) groups: Each group we would like to fetch offsets for ([]OffsetFetchRequestGroup | versions 8+) group_id: The group ID. (string | versions 8+) topics: Each topic we would like to fetch offsets for, or null to fetch offsets for all topics. ([]OffsetFetchRequestTopics | versions 8+) name: The topic name. (string | versions 8+) partition_indexes: The partition indexes we would like to fetch offsets for. ([]int32 | versions 8+) require_stable: Whether broker should hold on returning unstable offsets but set a retriable error code for the partitions. (bool | versions 7+)","ref":"KlifeProtocol.Messages.OffsetFetch.html#serialize_request/2","title":"KlifeProtocol.Messages.OffsetFetch.serialize_request/2","type":"function"},{"doc":"Kafka protocol OffsetForLeaderEpoch message Request versions summary: Version 1 is the same as version 0. Version 2 adds the current leader epoch to support fencing. Version 3 adds ReplicaId (the default is -2 which conventionally represents a &quot;debug&quot; consumer which is allowed to see offsets beyond the high watermark). Followers will use this replicaId when using an older version of the protocol. Version 4 enables flexible versions. Response versions summary: Version 1 added the leader epoch to the response. Version 2 added the throttle time. Version 3 is the same as version 2. Version 4 enables flexible versions.","ref":"KlifeProtocol.Messages.OffsetForLeaderEpoch.html","title":"KlifeProtocol.Messages.OffsetForLeaderEpoch","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.OffsetForLeaderEpoch.html#api_key/0","title":"KlifeProtocol.Messages.OffsetForLeaderEpoch.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 2+) topics: Each topic we fetched offsets for. ([]OffsetForLeaderTopicResult | versions 0+) topic: The topic name. (string | versions 0+) partitions: Each partition in the topic we fetched offsets for. ([]EpochEndOffset | versions 0+) error_code: The error code 0, or if there was no error. (int16 | versions 0+) partition: The partition index. (int32 | versions 0+) leader_epoch: The leader epoch of the partition. (int32 | versions 1+) end_offset: The end offset of the epoch. (int64 | versions 0+)","ref":"KlifeProtocol.Messages.OffsetForLeaderEpoch.html#deserialize_response/3","title":"KlifeProtocol.Messages.OffsetForLeaderEpoch.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.OffsetForLeaderEpoch.html#max_supported_version/0","title":"KlifeProtocol.Messages.OffsetForLeaderEpoch.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.OffsetForLeaderEpoch.html#min_supported_version/0","title":"KlifeProtocol.Messages.OffsetForLeaderEpoch.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: replica_id: The broker ID of the follower, of -1 if this request is from a consumer. (int32 | versions 3+) topics: Each topic to get offsets for. ([]OffsetForLeaderTopic | versions 0+) topic: The topic name. (string | versions 0+) partitions: Each partition to get offsets for. ([]OffsetForLeaderPartition | versions 0+) partition: The partition index. (int32 | versions 0+) current_leader_epoch: An epoch used to fence consumers/replicas with old metadata. If the epoch provided by the client is larger than the current epoch known to the broker, then the UNKNOWN_LEADER_EPOCH error code will be returned. If the provided epoch is smaller, then the FENCED_LEADER_EPOCH error code will be returned. (int32 | versions 2+) leader_epoch: The epoch to look up an offset for. (int32 | versions 0+)","ref":"KlifeProtocol.Messages.OffsetForLeaderEpoch.html#serialize_request/2","title":"KlifeProtocol.Messages.OffsetForLeaderEpoch.serialize_request/2","type":"function"},{"doc":"Kafka protocol Produce message Request versions summary: Version 1 and 2 are the same as version 0. Version 3 adds the transactional ID, which is used for authorization when attempting to write transactional data. Version 3 also adds support for Kafka Message Format v2. Version 4 is the same as version 3, but the requestor must be prepared to handle a KAFKA_STORAGE_ERROR. Version 5 and 6 are the same as version 3. Starting in version 7, records can be produced using ZStandard compression. See KIP-110. Starting in Version 8, response has RecordErrors and ErrorMEssage. See KIP-467. Version 9 enables flexible versions. Response versions summary: Version 1 added the throttle time. Version 2 added the log append time. Version 3 is the same as version 2. Version 4 added KAFKA_STORAGE_ERROR as a possible error code. Version 5 added LogStartOffset to filter out spurious OutOfOrderSequenceExceptions on the client. Version 8 added RecordErrors and ErrorMessage to include information about records that cause the whole batch to be dropped. See KIP-467 for details. Version 9 enables flexible versions.","ref":"KlifeProtocol.Messages.Produce.html","title":"KlifeProtocol.Messages.Produce","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.Produce.html#api_key/0","title":"KlifeProtocol.Messages.Produce.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: responses: Each produce response ([]TopicProduceResponse | versions 0+) name: The topic name (string | versions 0+) partition_responses: Each partition that we produced to within the topic. ([]PartitionProduceResponse | versions 0+) index: The partition index. (int32 | versions 0+) error_code: The error code, or 0 if there was no error. (int16 | versions 0+) base_offset: The base offset. (int64 | versions 0+) log_append_time_ms: The timestamp returned by broker after appending the messages. If CreateTime is used for the topic, the timestamp will be -1. If LogAppendTime is used for the topic, the timestamp will be the broker local time when the messages are appended. (int64 | versions 2+) log_start_offset: The log start offset. (int64 | versions 5+) record_errors: The batch indices of records that caused the batch to be dropped ([]BatchIndexAndErrorMessage | versions 8+) batch_index: The batch index of the record that cause the batch to be dropped (int32 | versions 8+) batch_index_error_message: The error message of the record that caused the batch to be dropped (string | versions 8+) error_message: The global error message summarizing the common root cause of the records that caused the batch to be dropped (string | versions 8+) throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 1+)","ref":"KlifeProtocol.Messages.Produce.html#deserialize_response/3","title":"KlifeProtocol.Messages.Produce.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.Produce.html#max_supported_version/0","title":"KlifeProtocol.Messages.Produce.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.Produce.html#min_supported_version/0","title":"KlifeProtocol.Messages.Produce.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: transactional_id: The transactional ID, or null if the producer is not transactional. (string | versions 3+) acks: The number of acknowledgments the producer requires the leader to have received before considering a request complete. Allowed values: 0 for no acknowledgments, 1 for only the leader and -1 for the full ISR. (int16 | versions 0+) timeout_ms: The timeout to await a response in milliseconds. (int32 | versions 0+) topic_data: Each topic to produce to. ([]TopicProduceData | versions 0+) name: The topic name. (string | versions 0+) partition_data: Each partition to produce to. ([]PartitionProduceData | versions 0+) index: The partition index. (int32 | versions 0+) records: The record data to be produced. (records | versions 0+)","ref":"KlifeProtocol.Messages.Produce.html#serialize_request/2","title":"KlifeProtocol.Messages.Produce.serialize_request/2","type":"function"},{"doc":"Kafka protocol RenewDelegationToken message Request versions summary: Version 1 is the same as version 0. Version 2 adds flexible version support Response versions summary: Starting in version 1, on quota violation, brokers send out responses before throttling. Version 2 adds flexible version support","ref":"KlifeProtocol.Messages.RenewDelegationToken.html","title":"KlifeProtocol.Messages.RenewDelegationToken","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.RenewDelegationToken.html#api_key/0","title":"KlifeProtocol.Messages.RenewDelegationToken.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: error_code: The error code, or 0 if there was no error. (int16 | versions 0+) expiry_timestamp_ms: The timestamp in milliseconds at which this token expires. (int64 | versions 0+) throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+)","ref":"KlifeProtocol.Messages.RenewDelegationToken.html#deserialize_response/3","title":"KlifeProtocol.Messages.RenewDelegationToken.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.RenewDelegationToken.html#max_supported_version/0","title":"KlifeProtocol.Messages.RenewDelegationToken.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.RenewDelegationToken.html#min_supported_version/0","title":"KlifeProtocol.Messages.RenewDelegationToken.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: hmac: The HMAC of the delegation token to be renewed. (bytes | versions 0+) renew_period_ms: The renewal time period in milliseconds. (int64 | versions 0+)","ref":"KlifeProtocol.Messages.RenewDelegationToken.html#serialize_request/2","title":"KlifeProtocol.Messages.RenewDelegationToken.serialize_request/2","type":"function"},{"doc":"Kafka protocol SaslAuthenticate message Request versions summary: Version 1 is the same as version 0. Version 2 adds flexible version support Response versions summary: Version 1 adds the session lifetime. Version 2 adds flexible version support","ref":"KlifeProtocol.Messages.SaslAuthenticate.html","title":"KlifeProtocol.Messages.SaslAuthenticate","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.SaslAuthenticate.html#api_key/0","title":"KlifeProtocol.Messages.SaslAuthenticate.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: error_code: The error code, or 0 if there was no error. (int16 | versions 0+) error_message: The error message, or null if there was no error. (string | versions 0+) auth_bytes: The SASL authentication bytes from the server, as defined by the SASL mechanism. (bytes | versions 0+) session_lifetime_ms: Number of milliseconds after which only re-authentication over the existing connection to create a new session can occur. (int64 | versions 1+)","ref":"KlifeProtocol.Messages.SaslAuthenticate.html#deserialize_response/3","title":"KlifeProtocol.Messages.SaslAuthenticate.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.SaslAuthenticate.html#max_supported_version/0","title":"KlifeProtocol.Messages.SaslAuthenticate.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.SaslAuthenticate.html#min_supported_version/0","title":"KlifeProtocol.Messages.SaslAuthenticate.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: auth_bytes: The SASL authentication bytes from the client, as defined by the SASL mechanism. (bytes | versions 0+)","ref":"KlifeProtocol.Messages.SaslAuthenticate.html#serialize_request/2","title":"KlifeProtocol.Messages.SaslAuthenticate.serialize_request/2","type":"function"},{"doc":"Kafka protocol SaslHandshake message Request versions summary: Version 1 supports SASL_AUTHENTICATE. NOTE: Version cannot be easily bumped due to incorrect client negotiation for clients &lt;= 2.4. See https:issues.apache.org/jira/browse/KAFKA-9577 Response versions summary: Version 1 is the same as version 0. NOTE: Version cannot be easily bumped due to incorrect client negotiation for clients &lt;= 2.4. See https:issues.apache.org/jira/browse/KAFKA-9577","ref":"KlifeProtocol.Messages.SaslHandshake.html","title":"KlifeProtocol.Messages.SaslHandshake","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.SaslHandshake.html#api_key/0","title":"KlifeProtocol.Messages.SaslHandshake.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: error_code: The error code, or 0 if there was no error. (int16 | versions 0+) mechanisms: The mechanisms enabled in the server. ([]string | versions 0+)","ref":"KlifeProtocol.Messages.SaslHandshake.html#deserialize_response/3","title":"KlifeProtocol.Messages.SaslHandshake.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.SaslHandshake.html#max_supported_version/0","title":"KlifeProtocol.Messages.SaslHandshake.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.SaslHandshake.html#min_supported_version/0","title":"KlifeProtocol.Messages.SaslHandshake.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: mechanism: The SASL mechanism chosen by the client. (string | versions 0+)","ref":"KlifeProtocol.Messages.SaslHandshake.html#serialize_request/2","title":"KlifeProtocol.Messages.SaslHandshake.serialize_request/2","type":"function"},{"doc":"Kafka protocol StopReplica message Request versions summary: Version 1 adds the broker epoch and reorganizes the partitions to be stored per topic. Version 2 is the first flexible version. Version 3 adds the leader epoch per partition (KIP-570). Version 4 adds KRaft Controller ID field as part of KIP-866 Response versions summary: Version 1 is the same as version 0. Version 2 is the first flexible version. Version 3 returns FENCED_LEADER_EPOCH if the epoch of the leader is stale (KIP-570).","ref":"KlifeProtocol.Messages.StopReplica.html","title":"KlifeProtocol.Messages.StopReplica","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.StopReplica.html#api_key/0","title":"KlifeProtocol.Messages.StopReplica.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: error_code: The top-level error code, or 0 if there was no top-level error. (int16 | versions 0+) partition_errors: The responses for each partition. ([]StopReplicaPartitionError | versions 0+) topic_name: The topic name. (string | versions 0+) partition_index: The partition index. (int32 | versions 0+) error_code: The partition error code, or 0 if there was no partition error. (int16 | versions 0+)","ref":"KlifeProtocol.Messages.StopReplica.html#deserialize_response/3","title":"KlifeProtocol.Messages.StopReplica.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.StopReplica.html#max_supported_version/0","title":"KlifeProtocol.Messages.StopReplica.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.StopReplica.html#min_supported_version/0","title":"KlifeProtocol.Messages.StopReplica.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: controller_id: The controller id. (int32 | versions 0+) is_k_raft_controller: If KRaft controller id is used during migration. See KIP-866 (bool | versions 4+) controller_epoch: The controller epoch. (int32 | versions 0+) broker_epoch: The broker epoch. (int64 | versions 1+) delete_partitions: Whether these partitions should be deleted. (bool | versions 0-2) ungrouped_partitions: The partitions to stop. ([]StopReplicaPartitionV0 | versions 0) topic_name: The topic name. (string | versions 0) partition_index: The partition index. (int32 | versions 0) topics: The topics to stop. ([]StopReplicaTopicV1 | versions 1-2) name: The topic name. (string | versions 1-2) partition_indexes: The partition indexes. ([]int32 | versions 1-2) topic_states: Each topic. ([]StopReplicaTopicState | versions 3+) topic_name: The topic name. (string | versions 3+) partition_states: The state of each partition ([]StopReplicaPartitionState | versions 3+) partition_index: The partition index. (int32 | versions 3+) leader_epoch: The leader epoch. (int32 | versions 3+) delete_partition: Whether this partition should be deleted. (bool | versions 3+)","ref":"KlifeProtocol.Messages.StopReplica.html#serialize_request/2","title":"KlifeProtocol.Messages.StopReplica.serialize_request/2","type":"function"},{"doc":"Kafka protocol SyncGroup message Request versions summary: Versions 1 and 2 are the same as version 0. Starting from version 3, we add a new field called groupInstanceId to indicate member identity across restarts. Version 4 is the first flexible version. Starting from version 5, the client sends the Protocol Type and the Protocol Name to the broker (KIP-559). The broker will reject the request if they are inconsistent with the Type and Name known by the broker. Response versions summary: Version 1 adds throttle time. Starting in version 2, on quota violation, brokers send out responses before throttling. Starting from version 3, syncGroupRequest supports a new field called groupInstanceId to indicate member identity across restarts. Version 4 is the first flexible version. Starting from version 5, the broker sends back the Protocol Type and the Protocol Name to the client (KIP-559).","ref":"KlifeProtocol.Messages.SyncGroup.html","title":"KlifeProtocol.Messages.SyncGroup","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.SyncGroup.html#api_key/0","title":"KlifeProtocol.Messages.SyncGroup.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 1+) error_code: The error code, or 0 if there was no error. (int16 | versions 0+) protocol_type: The group protocol type. (string | versions 5+) protocol_name: The group protocol name. (string | versions 5+) assignment: The member assignment. (bytes | versions 0+)","ref":"KlifeProtocol.Messages.SyncGroup.html#deserialize_response/3","title":"KlifeProtocol.Messages.SyncGroup.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.SyncGroup.html#max_supported_version/0","title":"KlifeProtocol.Messages.SyncGroup.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.SyncGroup.html#min_supported_version/0","title":"KlifeProtocol.Messages.SyncGroup.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: group_id: The unique group identifier. (string | versions 0+) generation_id: The generation of the group. (int32 | versions 0+) member_id: The member ID assigned by the group. (string | versions 0+) group_instance_id: The unique identifier of the consumer instance provided by end user. (string | versions 3+) protocol_type: The group protocol type. (string | versions 5+) protocol_name: The group protocol name. (string | versions 5+) assignments: Each assignment. ([]SyncGroupRequestAssignment | versions 0+) member_id: The ID of the member to assign. (string | versions 0+) assignment: The member assignment. (bytes | versions 0+)","ref":"KlifeProtocol.Messages.SyncGroup.html#serialize_request/2","title":"KlifeProtocol.Messages.SyncGroup.serialize_request/2","type":"function"},{"doc":"Kafka protocol TxnOffsetCommit message Request versions summary: Version 1 is the same as version 0. Version 2 adds the committed leader epoch. Version 3 adds the member.id, group.instance.id and generation.id. Response versions summary: Starting in version 1, on quota violation, brokers send out responses before throttling. Version 2 is the same as version 1. Version 3 adds illegal generation, fenced instance id, and unknown member id errors.","ref":"KlifeProtocol.Messages.TxnOffsetCommit.html","title":"KlifeProtocol.Messages.TxnOffsetCommit","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.TxnOffsetCommit.html#api_key/0","title":"KlifeProtocol.Messages.TxnOffsetCommit.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) topics: The responses for each topic. ([]TxnOffsetCommitResponseTopic | versions 0+) name: The topic name. (string | versions 0+) partitions: The responses for each partition in the topic. ([]TxnOffsetCommitResponsePartition | versions 0+) partition_index: The partition index. (int32 | versions 0+) error_code: The error code, or 0 if there was no error. (int16 | versions 0+)","ref":"KlifeProtocol.Messages.TxnOffsetCommit.html#deserialize_response/3","title":"KlifeProtocol.Messages.TxnOffsetCommit.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.TxnOffsetCommit.html#max_supported_version/0","title":"KlifeProtocol.Messages.TxnOffsetCommit.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.TxnOffsetCommit.html#min_supported_version/0","title":"KlifeProtocol.Messages.TxnOffsetCommit.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: transactional_id: The ID of the transaction. (string | versions 0+) group_id: The ID of the group. (string | versions 0+) producer_id: The current producer ID in use by the transactional ID. (int64 | versions 0+) producer_epoch: The current epoch associated with the producer ID. (int16 | versions 0+) generation_id: The generation of the consumer. (int32 | versions 3+) member_id: The member ID assigned by the group coordinator. (string | versions 3+) group_instance_id: The unique identifier of the consumer instance provided by end user. (string | versions 3+) topics: Each topic that we want to commit offsets for. ([]TxnOffsetCommitRequestTopic | versions 0+) name: The topic name. (string | versions 0+) partitions: The partitions inside the topic that we want to committ offsets for. ([]TxnOffsetCommitRequestPartition | versions 0+) partition_index: The index of the partition within the topic. (int32 | versions 0+) committed_offset: The message offset to be committed. (int64 | versions 0+) committed_leader_epoch: The leader epoch of the last consumed record. (int32 | versions 2+) committed_metadata: Any associated metadata the client wants to keep. (string | versions 0+)","ref":"KlifeProtocol.Messages.TxnOffsetCommit.html#serialize_request/2","title":"KlifeProtocol.Messages.TxnOffsetCommit.serialize_request/2","type":"function"},{"doc":"Kafka protocol UnregisterBroker message Request versions summary: Response versions summary:","ref":"KlifeProtocol.Messages.UnregisterBroker.html","title":"KlifeProtocol.Messages.UnregisterBroker","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.UnregisterBroker.html#api_key/0","title":"KlifeProtocol.Messages.UnregisterBroker.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: Duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) error_code: The error code, or 0 if there was no error. (int16 | versions 0+) error_message: The top-level error message, or null if there was no top-level error. (string | versions 0+)","ref":"KlifeProtocol.Messages.UnregisterBroker.html#deserialize_response/3","title":"KlifeProtocol.Messages.UnregisterBroker.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.UnregisterBroker.html#max_supported_version/0","title":"KlifeProtocol.Messages.UnregisterBroker.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.UnregisterBroker.html#min_supported_version/0","title":"KlifeProtocol.Messages.UnregisterBroker.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: broker_id: The broker ID to unregister. (int32 | versions 0+)","ref":"KlifeProtocol.Messages.UnregisterBroker.html#serialize_request/2","title":"KlifeProtocol.Messages.UnregisterBroker.serialize_request/2","type":"function"},{"doc":"Kafka protocol UpdateFeatures message Request versions summary: Response versions summary:","ref":"KlifeProtocol.Messages.UpdateFeatures.html","title":"KlifeProtocol.Messages.UpdateFeatures","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.UpdateFeatures.html#api_key/0","title":"KlifeProtocol.Messages.UpdateFeatures.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 0+) error_code: The top-level error code, or 0 if there was no top-level error. (int16 | versions 0+) error_message: The top-level error message, or null if there was no top-level error. (string | versions 0+) results: Results for each feature update. ([]UpdatableFeatureResult | versions 0+) feature: The name of the finalized feature. (string | versions 0+) error_code: The feature update error code or 0 if the feature update succeeded. (int16 | versions 0+) error_message: The feature update error, or null if the feature update succeeded. (string | versions 0+)","ref":"KlifeProtocol.Messages.UpdateFeatures.html#deserialize_response/3","title":"KlifeProtocol.Messages.UpdateFeatures.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.UpdateFeatures.html#max_supported_version/0","title":"KlifeProtocol.Messages.UpdateFeatures.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.UpdateFeatures.html#min_supported_version/0","title":"KlifeProtocol.Messages.UpdateFeatures.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: timeout_ms: How long to wait in milliseconds before timing out the request. (int32 | versions 0+) feature_updates: The list of updates to finalized features. ([]FeatureUpdateKey | versions 0+) feature: The name of the finalized feature to be updated. (string | versions 0+) max_version_level: The new maximum version level for the finalized feature. A value &gt;= 1 is valid. A value &lt; 1, is special, and can be used to request the deletion of the finalized feature. (int16 | versions 0+) allow_downgrade: DEPRECATED in version 1 (see DowngradeType). When set to true, the finalized feature version level is allowed to be downgraded/deleted. The downgrade request will fail if the new maximum version level is a value that's not lower than the existing maximum finalized version level. (bool | versions 0) upgrade_type: Determine which type of upgrade will be performed: 1 will perform an upgrade only (default), 2 is safe downgrades only (lossless), 3 is unsafe downgrades (lossy). (int8 | versions 1+) validate_only: True if we should validate the request, but not perform the upgrade or downgrade. (bool | versions 1+)","ref":"KlifeProtocol.Messages.UpdateFeatures.html#serialize_request/2","title":"KlifeProtocol.Messages.UpdateFeatures.serialize_request/2","type":"function"},{"doc":"Kafka protocol UpdateMetadata message Request versions summary: Version 1 allows specifying multiple endpoints for each broker. Version 2 adds the rack. Version 3 adds the listener name. Version 4 adds the offline replica list. Version 5 adds the broker epoch field and normalizes partitions by topic. Version 7 adds topicId Version 8 adds KRaft Controller ID field as part of KIP-866 Response versions summary: Versions 1, 2, 3, 4, and 5 are the same as version 0","ref":"KlifeProtocol.Messages.UpdateMetadata.html","title":"KlifeProtocol.Messages.UpdateMetadata","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.UpdateMetadata.html#api_key/0","title":"KlifeProtocol.Messages.UpdateMetadata.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: error_code: The error code, or 0 if there was no error. (int16 | versions 0+)","ref":"KlifeProtocol.Messages.UpdateMetadata.html#deserialize_response/3","title":"KlifeProtocol.Messages.UpdateMetadata.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.UpdateMetadata.html#max_supported_version/0","title":"KlifeProtocol.Messages.UpdateMetadata.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.UpdateMetadata.html#min_supported_version/0","title":"KlifeProtocol.Messages.UpdateMetadata.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: controller_id: The controller id. (int32 | versions 0+) is_k_raft_controller: If KRaft controller id is used during migration. See KIP-866 (bool | versions 8+) controller_epoch: The controller epoch. (int32 | versions 0+) broker_epoch: The broker epoch. (int64 | versions 5+) ungrouped_partition_states: In older versions of this RPC, each partition that we would like to update. ([]UpdateMetadataPartitionState | versions 0-4) topic_name: In older versions of this RPC, the topic name. (string | versions 0-4) partition_index: The partition index. (int32 | versions 0+) controller_epoch: The controller epoch. (int32 | versions 0+) leader: The ID of the broker which is the current partition leader. (int32 | versions 0+) leader_epoch: The leader epoch of this partition. (int32 | versions 0+) isr: The brokers which are in the ISR for this partition. ([]int32 | versions 0+) zk_version: The Zookeeper version. (int32 | versions 0+) replicas: All the replicas of this partition. ([]int32 | versions 0+) offline_replicas: The replicas of this partition which are offline. ([]int32 | versions 4+) topic_states: In newer versions of this RPC, each topic that we would like to update. ([]UpdateMetadataTopicState | versions 5+) topic_name: The topic name. (string | versions 5+) topic_id: The topic id. (uuid | versions 7+) partition_states: The partition that we would like to update. ([]UpdateMetadataPartitionState | versions 5+) topic_name: In older versions of this RPC, the topic name. (string | versions 0-4) partition_index: The partition index. (int32 | versions 0+) controller_epoch: The controller epoch. (int32 | versions 0+) leader: The ID of the broker which is the current partition leader. (int32 | versions 0+) leader_epoch: The leader epoch of this partition. (int32 | versions 0+) isr: The brokers which are in the ISR for this partition. ([]int32 | versions 0+) zk_version: The Zookeeper version. (int32 | versions 0+) replicas: All the replicas of this partition. ([]int32 | versions 0+) offline_replicas: The replicas of this partition which are offline. ([]int32 | versions 4+) live_brokers: ([]UpdateMetadataBroker | versions 0+) id: The broker id. (int32 | versions 0+) v0_host: The broker hostname. (string | versions 0) v0_port: The broker port. (int32 | versions 0) endpoints: The broker endpoints. ([]UpdateMetadataEndpoint | versions 1+) port: The port of this endpoint (int32 | versions 1+) host: The hostname of this endpoint (string | versions 1+) listener: The listener name. (string | versions 3+) security_protocol: The security protocol type. (int16 | versions 1+) rack: The rack which this broker belongs to. (string | versions 2+)","ref":"KlifeProtocol.Messages.UpdateMetadata.html#serialize_request/2","title":"KlifeProtocol.Messages.UpdateMetadata.serialize_request/2","type":"function"},{"doc":"Kafka protocol Vote message Request versions summary: Response versions summary:","ref":"KlifeProtocol.Messages.Vote.html","title":"KlifeProtocol.Messages.Vote","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.Vote.html#api_key/0","title":"KlifeProtocol.Messages.Vote.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: error_code: The top level error code. (int16 | versions 0+) topics: ([]TopicData | versions 0+) topic_name: The topic name. (string | versions 0+) partitions: ([]PartitionData | versions 0+) partition_index: The partition index. (int32 | versions 0+) error_code: (int16 | versions 0+) leader_id: The ID of the current leader or -1 if the leader is unknown. (int32 | versions 0+) leader_epoch: The latest known leader epoch (int32 | versions 0+) vote_granted: True if the vote was granted and false otherwise (bool | versions 0+)","ref":"KlifeProtocol.Messages.Vote.html#deserialize_response/3","title":"KlifeProtocol.Messages.Vote.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.Vote.html#max_supported_version/0","title":"KlifeProtocol.Messages.Vote.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.Vote.html#min_supported_version/0","title":"KlifeProtocol.Messages.Vote.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: cluster_id: (string | versions 0+) topics: ([]TopicData | versions 0+) topic_name: The topic name. (string | versions 0+) partitions: ([]PartitionData | versions 0+) partition_index: The partition index. (int32 | versions 0+) candidate_epoch: The bumped epoch of the candidate sending the request (int32 | versions 0+) candidate_id: The ID of the voter sending the request (int32 | versions 0+) last_offset_epoch: The epoch of the last record written to the metadata log (int32 | versions 0+) last_offset: The offset of the last record written to the metadata log (int64 | versions 0+)","ref":"KlifeProtocol.Messages.Vote.html#serialize_request/2","title":"KlifeProtocol.Messages.Vote.serialize_request/2","type":"function"},{"doc":"Kafka protocol WriteTxnMarkers message Request versions summary: Version 1 enables flexible versions. Response versions summary:","ref":"KlifeProtocol.Messages.WriteTxnMarkers.html","title":"KlifeProtocol.Messages.WriteTxnMarkers","type":"module"},{"doc":"Returns the message api key number.","ref":"KlifeProtocol.Messages.WriteTxnMarkers.html#api_key/0","title":"KlifeProtocol.Messages.WriteTxnMarkers.api_key/0","type":"function"},{"doc":"Receive a binary in the kafka wire format and deserialize it into a map. Response content fields: markers: The results for writing makers. ([]WritableTxnMarkerResult | versions 0+) producer_id: The current producer ID in use by the transactional ID. (int64 | versions 0+) topics: The results by topic. ([]WritableTxnMarkerTopicResult | versions 0+) name: The topic name. (string | versions 0+) partitions: The results by partition. ([]WritableTxnMarkerPartitionResult | versions 0+) partition_index: The partition index. (int32 | versions 0+) error_code: The error code, or 0 if there was no error. (int16 | versions 0+)","ref":"KlifeProtocol.Messages.WriteTxnMarkers.html#deserialize_response/3","title":"KlifeProtocol.Messages.WriteTxnMarkers.deserialize_response/3","type":"function"},{"doc":"Returns the current max supported version of this message.","ref":"KlifeProtocol.Messages.WriteTxnMarkers.html#max_supported_version/0","title":"KlifeProtocol.Messages.WriteTxnMarkers.max_supported_version/0","type":"function"},{"doc":"Returns the current min supported version of this message.","ref":"KlifeProtocol.Messages.WriteTxnMarkers.html#min_supported_version/0","title":"KlifeProtocol.Messages.WriteTxnMarkers.min_supported_version/0","type":"function"},{"doc":"Receives a map and serialize it to kafka wire format of the given version. Input content fields: markers: The transaction markers to be written. ([]WritableTxnMarker | versions 0+) producer_id: The current producer ID. (int64 | versions 0+) producer_epoch: The current epoch associated with the producer ID. (int16 | versions 0+) transaction_result: The result of the transaction to write to the partitions (false = ABORT, true = COMMIT). (bool | versions 0+) topics: Each topic that we want to write transaction marker(s) for. ([]WritableTxnMarkerTopic | versions 0+) name: The topic name. (string | versions 0+) partition_indexes: The indexes of the partitions to write transaction markers for. ([]int32 | versions 0+) coordinator_epoch: Epoch associated with the transaction state partition hosted by this transaction coordinator (int32 | versions 0+)","ref":"KlifeProtocol.Messages.WriteTxnMarkers.html#serialize_request/2","title":"KlifeProtocol.Messages.WriteTxnMarkers.serialize_request/2","type":"function"},{"doc":"This is an Elixir implementation of the Kafka protocol . It enables communication with Kafka brokers using standard Elixir data structures without the need for manual serialization. The implementation is specifically designed to handle only the wire protocol. Therefore, it should be used inside a full Kafka client rather than being directly integrated into application code.","ref":"readme.html","title":"Klife Protocol","type":"extras"},{"doc":"One of the main features of this library is its ability to generate Elixir code using Kafka message definitions . This ensures that all currently available and future messages (excluding the ones mentioned below) should be easily supported in all versions by the implementation. This implementation of the Kafka protocol supports all currently available messages and versions, except for Fetch versions below 4. This is due to a change in record batch serialization in newer versions (&gt;=4) of this message. As a result, the library is NOT compatible with Kafka versions prior 0.11.","ref":"readme.html#supported-messages","title":"Klife Protocol - Supported messages","type":"extras"},{"doc":"This is an example of usage that creates a connection with a broker, send the API version message and handle the response. alias KlifeProtocol.Socket alias KlifeProtocol.Messages { :ok , socket } = Socket . connect ( &quot;localhost&quot; , 19092 , [ backend : :gen_tcp , active : false ] ) version = 0 input = %{ headers : %{ correlation_id : 123 } , content : %{ } } serialized_msg = Messages.ApiVersions . serialize_request ( input , version ) :ok = :gen_tcp . send ( socket , serialized_msg ) { :ok , received_data } = :gen_tcp . recv ( socket , 0 , 5_000 ) { :ok , response } = Messages.ApiVersions . deserialize_response ( received_data , version ) Inside the response variable you will get something like this: %{ content : %{ api_keys : [ %{ api_key : 0 , max_version : 9 , min_version : 0 } , %{ api_key : 1 , max_version : 13 , min_version : 0 } , %{ api_key : 2 , max_version : 7 , min_version : 0 } , %{ api_key : 3 , max_version : 12 , min_version : 0 } , ... ] , error_code : 0 , throttle_time_ms : 0 } , headers : %{ correlation_id : 123 } }","ref":"readme.html#basic-example","title":"Klife Protocol - Basic example","type":"extras"},{"doc":"Each message has it's own set of fields, as described in the Kafka official documentation. On this library, each message has it's own module within KlifeProtocol.Messages namespace. In the previous example we used KlifeProtocol.Messages.ApiVersions which stands for the API version message . Each message contains 2 main functions: serialize_request/2 : Receives a map and serialize it to kafka wire format of the given version. deserialize_response/3 : Receive a binary in the kafka wire format and deserialize it into a map. You can find the available fields directly on the Kafka documentation or inside the message module documentation which contains all the possible fields, along with extra comments describing each one of them. All fields can be provided (for serialization) or returned (for deseriaization) inside the content map attribute. Serialize Request It expects a map containing 2 attributes headers and content that are also maps. The required fields of each map depends on the version being handled and can be found on the documentation. It returns the binary in the kafka's wire format. For instance the Messages.ApiVersions.serialize_request/2 has the following documentation: @doc &quot;&quot;&quot; Content fields: - client_software_name: The name of the client. (string | versions 3+) - client_software_version: The version of the client. (string | versions 3+) &quot;&quot;&quot; Which means that on versions 3+ you can provide client_software_name and client_software_version on the content map of the input, like this: input = %{ headers : %{ correlation_id : 123 } , content : %{ client_software_name : &quot;some_name&quot; } } serialized_msg = Messages.ApiVersions . serialize_request ( input , 3 ) Deserialize Response It expects the binary, version and a boolean indicating if the given binary contains the header or not (defaults to true, meaning that the header data is expected to be present). It returns a tuple {:ok, map} and the map always have the content attribute and may have the headers attribute depending on the with_header? boolean of the input. The possible content fields are describe the same way of the serialization process. For instance the Messages.ApiVersions.deserialize_response/3 has the following documentation: @doc &quot;&quot;&quot; Content fields: - error_code: The top-level error code. (int16 | versions 0+) - api_keys: The APIs supported by the broker. ([]ApiVersion | versions 0+) - api_key: The API index. (int16 | versions 0+) - min_version: The minimum supported version, inclusive. (int16 | versions 0+) - max_version: The maximum supported version, inclusive. (int16 | versions 0+) - throttle_time_ms: The duration in milliseconds for which the request was throttled due to a quota violation, or zero if the request did not violate any quota. (int32 | versions 1+) - supported_features: Features supported by the broker. ([]SupportedFeatureKey | versions 3+) - name: The name of the feature. (string | versions 3+) - min_version: The minimum supported version for the feature. (int16 | versions 3+) - max_version: The maximum supported version for the feature. (int16 | versions 3+) - finalized_features_epoch: The monotonically increasing epoch for the finalized features information. Valid values are &gt;= 0. A value of -1 is special and represents unknown epoch. (int64 | versions 3+) - finalized_features: List of cluster-wide finalized features. The information is valid only if FinalizedFeaturesEpoch &gt;= 0. ([]FinalizedFeatureKey | versions 3+) - name: The name of the feature. (string | versions 3+) - max_version_level: The cluster-wide finalized max version level for the feature. (int16 | versions 3+) - min_version_level: The cluster-wide finalized min version level for the feature. (int16 | versions 3+) - zk_migration_ready: Set by a KRaft controller if the required configurations for ZK migration are present (bool | versions 3+) &quot;&quot;&quot; { :ok , %{ headers : headers , content : content } } = Messages.ApiVersions . deserialize_response ( binary , 3 ) %{ error_code : 0 , api_keys : api_keys , throttle_time_ms : 0 , finalized_features_epoch : 0 } = content Headerless deserialization If for some reason you need to take a peek at the message header before fully deserialize it you can use the KlifeProtocol.Header.deserialize_response/2 function. It expects a binary and version, returning the header map and the remaning binary. But notice that the header version is different from the message version. alias KlifeProtocol.Socket alias KlifeProtocol.Messages { :ok , socket } = Socket . connect ( &quot;localhost&quot; , 19092 , [ backend : :gen_tcp , active : false ] ) version = 0 input = %{ headers : %{ correlation_id : 123 } , content : %{ } } serialized_msg = Messages.ApiVersions . serialize_request ( input , version ) :ok = :gen_tcp . send ( socket , serialized_msg ) { :ok , received_data } = :gen_tcp . recv ( socket , 0 , 5_000 ) { :ok , { headers_map , rest_data } } = KlifeProtocol.Header . deserialize_response ( received_data , 0 ) After, you can use the deserialize_response/3 function of the messages API, passing false on the third argument to prevent header deserailization again and deserialize the remaing of the binary. { :ok , %{ content : content } } = Messages.ApiVersions . deserialize_response ( rest_data , version , false )","ref":"readme.html#messages-api","title":"Klife Protocol - Messages API","type":"extras"},{"doc":"Currently supports two compression methods: snappy using sanppyer library and gzip using erlang zlib library . To configure the compression strategy, along with other important data such as timestampType and isTransactional , you can utilize the Kafka record batch's attributes byte . Klife protocol provides an interface to simplify the creation of this attributes using the encode_attributes/1 and decode_attributes/1 functions of the RecordBatch module. Here's an example: alias KlifeProtocol.RecordBatch opts = [ compression : :snappy , timestamp_type : :log_append_time , is_transactional : true , is_control_batch : true , has_delete_horizon : true ] attr_val = RecordBatch . encode_attributes ( opts ) %{ compression : :snappy , timestamp_type : :log_append_time , is_transactional : true , is_control_batch : true , has_delete_horizon : true } = RecordBatch . decode_attributes ( attr_val ) With these functions, a client can easily generate and decode attributes for each record batch it handles.","ref":"readme.html#compression-and-record-batch-attributes","title":"Klife Protocol - Compression and Record Batch Attributes","type":"extras"},{"doc":"This section provides performance benchmarks for the main use cases of produce serialization and fetch deserialization, conducted using the benchee tool . The benchmarks measure only the serialization work, as the Kafka cluster is running solely to retrieve data samples for benchmarking purposes. Note that network latency is not included in the measurements, only serialization/deserialization performance. The benchmarks were conducted on a personal computer with the following specifications, using only a single core. The operations were performed on messages containing a single record batch with 1, 10, 50 and 100 records to/from a single partition without compression. CPU : Intel i7 10750 h OS : Ubuntu 22.04 Elixir : 1.14 . 3 - OTP - 25 Kernel : 5.19 . 0 All benchmarks can be executed by running the benchmark mix task from the project's base folder: bash run - kafka . sh mix benchmark produce_serialization mix benchmark fetch_deserialization bash stop - kafka . sh Produce Serialization REC QTY REC SIZE REC/S IPS AVG P50 P99 SD Mem. Usg 1 500 kb 1.54 k 1.54 K 648 μs 648 μs 873 μs ±12% 4 kb 10 50 kb 16.7 k 1.67 K 597 μs 577 μs 945 μs ±16% 11 kb 50 10 kb 83.5 k 1.67 K 598 μs 577 μs 945 μs ±16% 45 kb 100 5 kb 157 k 1.57 K 637 μs 620 μs 933 μs ±14% 86 kb Fetch Deserialization REC QTY REC SIZE REC/S IPS AVG P50 P99 SD Mem. Usg 1 500 kb 4.54 k 4.54 k 220 μs 206 μs 370 μs ±15% 19 kb 10 50 kb 39.7 k 3.97 k 252 μs 232 μs 377 μs ±17% 62 kb 50 10 kb 131 k 2.62 k 382 μs 370 μs 521 μs ±14% 250 kb 100 5 kb 200 k 2.00 k 500 μs 490 μs 652 μs ±13% 486 kb","ref":"readme.html#performance","title":"Klife Protocol - Performance","type":"extras"},{"doc":"The project is composed by 5 main components: Module generator: This component performs a variety of tasks to convert Kafka's message definitions into message modules. Message Modules: These modules serve as the primary interface for clients using this library. They enable the serialization and deserialization of specific messages in the Kafka protocol. Serializer: This module is responsible for transforming Elixir maps into appropriate binaries using the schemas defined by the message modules. These binaries can then be sent across the wire to Kafka brokers. Deserializer: This module handles the conversion of binaries received from Kafka brokers into Elixir maps. It utilizes the schemas defined by the message modules. Socket: Simple wrapper of :gen_tcp and :ssl connect/3 function that set socket opts that are needed to proper communicate with kafka broker packet: 4 and binary . It is intended to be used only for the socket initialization, all other operations must be done using :gen_tcp or :ssl directly.","ref":"readme.html#project-overview","title":"Klife Protocol - Project Overview","type":"extras"},{"doc":"bash run - kafka . sh mix test bash stop - kafka . sh In order to prevent race conditions with kafka initialization is recommended to wait a couple seconds between bash run-kafka.sh and mix test . If you want to run tests using a SSL connection, you can use an env var CONN_MODE=SSL like this: bash run - kafka . sh CONN_MODE = SSL mix test bash stop - kafka . sh","ref":"readme.html#running-tests","title":"Klife Protocol - Running Tests","type":"extras"}]